SystemOrganization addCategory: #'MC2-Repositories-Directory'!
SystemOrganization addCategory: #'MC2-Repositories-File'!
SystemOrganization addCategory: #'MC2-Repositories-FileOut'!
SystemOrganization addCategory: #'MC2-Repositories-Net'!
SystemOrganization addCategory: #'MC2-Repositories-Tests'!

MDElementHandler subclass: #MDChunkHandler
	instanceVariableNames: 'exporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDChunkHandler class methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2009 22:40'!
exporter: aChunkExporter
	^ self basicNew initializeWithExporter: aChunkExporter! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:44'!
handleClass: anElement
	^ exporter addChunk: (MDClassChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:41'!
handleClassComment: anElement
	^ exporter addChunk: (MDClassCommentChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:45'!
handleClassInstVar: anElement
	^ exporter addChunk: (MDClassInstVarChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:46'!
handleClassVar: anElement
	^ exporter addChunk: (MDClassVarChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:46'!
handleInstVar: anElement
	^ exporter addChunk: (MDInstVarChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:47'!
handleMethod: anElement
	^ exporter addChunk: (MDMethodChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'smalltalk' stamp: 'cwp 10/17/2009 22:47'!
handlePoolImport: anElement
	^ exporter addChunk: (MDPoolImportChunk forElement: anElement)! !

!MDChunkHandler methodsFor: 'initialize-release' stamp: 'cwp 10/17/2009 22:40'!
initializeWithExporter: anExporter
	self initialize.
	exporter := anExporter! !

MDRepositoryTest subclass: #MDDirectoryRepositoryTest
	instanceVariableNames: 'directory tearDownRepositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDDirectoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 8/18/2008 20:03'!
directoryName
	^ 'TestRepository'! !

!MDDirectoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 10/27/2008 23:45'!
newRepository
	^ self noteRepository: (MDDirectoryRepository on: directory)! !

!MDDirectoryRepositoryTest methodsFor: 'running' stamp: 'cwp 10/27/2008 23:45'!
noteRepository: aRepository 
	^ tearDownRepositories add: aRepository! !

!MDDirectoryRepositoryTest methodsFor: 'constructing' stamp: 'cwp 10/27/2008 23:45'!
secondRepository
	| dirName dir |
	dirName := self directoryName , '2'.
	dir := FileDirectory default directoryNamed: dirName.
	^ self noteRepository: (MDDirectoryRepository on: dir)! !

!MDDirectoryRepositoryTest methodsFor: 'running' stamp: 'cwp 10/27/2008 23:43'!
setUp
	directory := FileDirectory default directoryNamed: self directoryName.
	tearDownRepositories := OrderedCollection new.
	super setUp! !

!MDDirectoryRepositoryTest methodsFor: 'running' stamp: 'cwp 10/25/2008 18:30'!
tearDown
	super tearDown.
	tearDownRepositories do: 
		[:ea | 
		ea close.
		(ea instVarNamed: 'directory') recursiveDelete].
! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/25/2008 15:37'!
testDiscovery
	| version retrieved file |
	version := MDTestBuilder new version.
	file := MDFileRepository on: 
		(directory newFileNamed: 'fb6a3295-edc1-47c3-aaa2-588649a0c11d.mcr').
	file put: version.
	file close.
	retrieved := repository get: version hashstamp.
	self assert: retrieved = version! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/27/2008 22:44'!
testLoad
	| newName properties |
	newName := repository name , '-Renamed'.
	properties := MDPropertyDictionary new
		type: repository class type;
		name: newName;
		yourself.
	repository properties: properties.
	self assert: repository name = newName.
	self assert: (FileDirectory default directoryExists: newName).! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 11/23/2008 15:48'!
testLoadNewInstance
	| id newName properties newRepository |
	id := MDHashstamp fromString: '+++++8cdN1p7Wv6oyR1zmR0Mf3oRYhjR'.
	newName := repository name , '-Renamed'.
	properties := MDPropertyDictionary new
		type: repository class type;
		name: newName;
		primaryName: 'abc';
		yourself.
	newRepository := MDDirectoryRepository id: id.
	self noteRepository: newRepository.
	newRepository properties: properties.
	self assert: newRepository name = newName.
	self assert: (FileDirectory default directoryExists: newName)! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 11/23/2008 15:54'!
testLoadPrimaryName
	| newName properties |
	newName := 'abc'.
	properties := MDPropertyDictionary new
		type: repository class type;
		name: repository name;
		primaryName: newName;
		yourself.
	repository properties: properties.
	self assert: repository primaryName = newName.
	self assert: ((FileDirectory default directoryNamed: repository name) 
					fileExists: repository primaryFilename).! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 8/21/2008 20:23'!
testNameFromDirectory
	self assert: repository name = 'TestRepository'! !

!MDDirectoryRepositoryTest methodsFor: 'tests' stamp: 'cwp 11/23/2008 13:19'!
testProperties
	| properties |
	properties := repository properties.
	self assert: properties type = #McrDirectory.
	self assert: properties name = 'TestRepository'.
	self assert: properties primaryName = MDPlatform current initials! !

MDRepositoryTest subclass: #MDFileRepositoryTest
	instanceVariableNames: 'second tearDownRepositories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 10/25/2008 15:38'!
addTearDownFilename: aString
	^ tearDownFilenames add: aString! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 12/23/2007 00:06'!
destroyRepository: aRepository named: aString
	aRepository close.
	FileDirectory default deleteFileNamed: (aString, '.mcr')! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 10/25/2008 19:16'!
isWindows
	"Some tests won't work on Windows, because they simulate the interaction of
	several images using a file repository at the same time. The Windows VM doesn't
	allow more than one filestream on a given file at the same time, so the test fail,
	even though the code works correctly in actual usage. Rather than create more
	elaborate tests, we just skip them on Windows... they run fine with Mac and Unix."
	
	^ FileDirectory default class = DosFileDirectory ! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 10/27/2008 23:45'!
newRepository
	^ self noteRepository: (MDFileRepository named: self repositoryFileName)! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 10/27/2008 23:45'!
noteRepository: aRepository 
	^ tearDownRepositories add: aRepository! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 1/1/2007 10:02'!
repositoryFileName
	^ 'test-file-repository'! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 12/23/2007 00:10'!
secondFileName
	^ 'test-file-repository2'! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 10/27/2008 23:45'!
secondRepository
	^ second := self noteRepository: (MDFileRepository named: self secondFileName)! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 10/25/2008 19:10'!
setUp
	tearDownRepositories := OrderedCollection new.
	super setUp! !

!MDFileRepositoryTest methodsFor: 'running' stamp: 'cwp 10/25/2008 18:59'!
tearDown
	super tearDown.
	tearDownRepositories do: 
		[:each | 
		each close.
		FileDirectory default deleteFileNamed: each name].
	tearDownRepositories := nil! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/27/2008 23:45'!
testConcurrentAppend
	| version get |
	self isWindows ifTrue: [ ^ self ].
	second := self noteRepository: self newRepository.
	version := self version.
	repository put: version.
	self 
		assert: (repository get: version hashstamp)
		isEquivalentTo: version.
	get := second get: version hashstamp.
	self assert: get notNil.
	self 
		assert: get
		isEquivalentTo: version! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/25/2008 14:54'!
testDeletedFile
	| version result |
	version := self version.
	repository put: version.
	repository close.
	FileDirectory default deleteFileNamed: self repositoryFileName , '.mcr'.
	(repository instVarNamed: 'dataStream') stream reopen.
	
	result := repository get: version hashstamp.
	self assert: result isNil! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/25/2008 18:54'!
testLoad
	| properties newName directory |
	newName := 'test-renamed-repository.mcr'.
	directory := FileDirectory default.
	properties := MDPropertyDictionary new name: newName; yourself.
	repository properties: properties.
	self assert: repository name = newName.
	self assert: (directory fileExists: newName)! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/27/2008 23:45'!
testLoadNewInstance
	| properties newName directory id newRepository |
	id := MDHashstamp fromString: '+++++973ucQcsL3sjjw-+yt-8Hm+W+YD'.
	newName := 'test-renamed-repository.mcr'.
	directory := FileDirectory default.
	properties := MDPropertyDictionary new
		name: newName;
		yourself.
	newRepository := MDFileRepository id: id.
	newRepository properties: properties.
	self noteRepository: newRepository.
	self assert: newRepository name = newName.
	self assert: (directory fileExists: newName)! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/27/2008 22:35'!
testProperties
	| properties expectedName |
	properties := repository properties.
	self assert: properties type = #McrFile.

	expectedName := self repositoryFileName , repository class extension.
	self assert: properties name = expectedName! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/27/2008 23:45'!
testReopen
	| version |
	version := self version.
	repository put: version.
	self 
		assert: (repository get: version hashstamp)
		isEquivalentTo: version.
	repository close.
	repository := self noteRepository: self newRepository.
	self 
		assert: (repository get: version hashstamp)
		isEquivalentTo: version! !

!MDFileRepositoryTest methodsFor: 'tests' stamp: 'cwp 10/25/2008 19:13'!
testTruncatedFile
	| result builder alpha beta other |
	self isWindows ifTrue: [^ self].
	builder := MDTestBuilder new.
	alpha := builder versionWith: #alpha.
	beta := builder versionWith: #beta.
	repository put: alpha.
	repository put: beta.
	
	FileDirectory default deleteFileNamed: self repositoryFileName , '.mcr'.
	other := self newRepository.
	other put: alpha.
	(repository instVarNamed: 'dataStream') stream reopen.
	
	result := repository get: alpha hashstamp.
	self deny: result isNil.
	
	result := repository get: beta hashstamp.
	self assert: result isNil.! !

MDRepositoryTest subclass: #MDNetRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:00'!
newRepository
	^ MDFakeLink repositoryForTesting ! !

!MDNetRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2008 01:26'!
testLoad
	| properties |
	properties := MDPropertyDictionary new
		host: 'example.com';
		port: 7902;
		yourself.
	repository properties: properties.
	self assert: repository locator host = 'example.com'.
	self assert: repository locator port = 7902.! !

!MDNetRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2008 01:13'!
testProperties
	| properties |
	properties := repository properties.
	self assert: properties type = #Mnrp.
	self assert: properties host = 'fakehost.com'.
	self assert: properties port = 7901.! !

Object subclass: #MDByteIndex
	instanceVariableNames: 'keySize valueSize streamSize stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-File'!

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2005 03:08'!
stream: aStream keySize: keyNumber valueSize: valueNumber
	^ self stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: aStream size! !

!MDByteIndex class methodsFor: 'as yet unclassified' stamp: 'avi 3/19/2005 02:41'!
stream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	^ self basicNew setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray
	^ self at: keyArray ifAbsent: [self error: 'Could not find key ', keyArray printString]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:36'!
at: keyArray ifAbsent: errorBlock
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	^ self basicAt: keyArray ifAbsent: errorBlock! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:37'!
at: keyArray put: valueArray
	keyArray size = keySize ifFalse: [self error: 'Key must be exactly ', keySize asString, ' bytes'].
	valueArray size = valueSize ifFalse: [self error: 'Value must be exactly ', valueSize asString, ' bytes'].
	^ self basicAt: keyArray put: valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
basicAt: keyArray ifAbsent: errorBlock
	| i key |
	i := self scanFor: keyArray.
	key := self keyBytesAtIndex: i.
	^ key = keyArray
		ifTrue: [self valueBytesAtIndex: i]
		ifFalse: errorBlock! !

!MDByteIndex methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
basicAt: keyArray put: valueArray
	| i key |
	i := self scanFor: keyArray.
	key := self keyBytesAtIndex: i.
	key = keyArray ifFalse:
		[self writeTally: self tally + 1.
		self writeKeyBytes: keyArray atIndex: i].
	self writeValueBytes: valueArray atIndex: i.
	^ valueArray! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:45'!
hash: keyArray
	^ keyArray hash! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:38'!
keyBytesAtIndex: i
	self seekTo: i.
	^ stream atEnd
		ifTrue: [ByteArray new: keySize]
		ifFalse: [stream next: keySize]! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
keySize
	^ keySize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/15/2005 03:07'!
maxIndex
	^ streamSize - 4 // self recordSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:43'!
recordSize
	^ keySize + valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
scanFor: keyArray
	| start |
	start := (self hash: keyArray) \\ self maxIndex.
	start to: self maxIndex do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	0 to: start - 1 do: [:i | (self scanFor: keyArray at: i) ifTrue: [^ i]].
	
	self error: 'Index is full'! !

!MDByteIndex methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
scanFor: keyArray at: i
	| key |
	key := self keyBytesAtIndex: i.
	^ key = keyArray or: [key allSatisfy: [:b | b = 0]]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
seekTo: i
	stream position: i * self recordSize + 4! !

!MDByteIndex methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:11'!
setStream: aStream keySize: keyNumber valueSize: valueNumber streamSize: streamNumber
	keySize := keyNumber.
	valueSize := valueNumber.
	streamSize := streamNumber.
	stream := aStream.
	stream binary! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/19/2005 02:51'!
streamSize
	^ streamSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/15/2005 03:23'!
tally
	stream reset.
	^ stream atEnd
		ifTrue: [0]
		ifFalse: [stream nextInt32]! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:41'!
valueBytesAtIndex: i
	self seekTo: i.
	stream skip: keySize.
	^ stream next: valueSize! !

!MDByteIndex methodsFor: 'accessing' stamp: 'avi 3/13/2005 03:05'!
valueSize
	^ valueSize! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeKeyBytes: keyBytes atIndex: i
	self seekTo: i.
	stream nextPutAll: keyBytes! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:42'!
writeTally: aNumber
	stream reset.
	stream nextInt32Put: aNumber! !

!MDByteIndex methodsFor: 'private' stamp: 'avi 3/13/2005 03:40'!
writeValueBytes: valueBytes atIndex: i
	self seekTo: i.
	stream skip: keySize.
	stream nextPutAll: valueBytes! !

Object subclass: #MDChunk
	instanceVariableNames: 'element properties invisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDChunk class methodsFor: 'as yet unclassified' stamp: 'cwp 3/25/2008 22:21'!
forElement: anElement
	^ self new setElement: anElement! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 4/27/2008 00:29'!
beInvisible
	invisible := true! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 5/2/2008 21:35'!
element
	^ element! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 5/3/2008 00:16'!
hasSuperclass: aSymbol
	^ false! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 4/27/2008 00:29'!
isRemoval
	^ properties isNil! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 5/3/2008 00:15'!
isSuperOf: aChunk
	^ false! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 5/2/2008 21:43'!
joinSectionIn: aDictionary 
	| section |
	section := aDictionary 
		at: element theClassName
		ifAbsentPut: [ MDFileOutSection new ].
	section addChunk: self! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 4/27/2008 00:06'!
load: aPropertyDictionary
	properties := aPropertyDictionary.
	! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 5/20/2008 22:41'!
printSortKeyOn: stream 
	^ stream
		nextPut: self typeChar;
		nextPut: $!!;
		nextPutAll: self sortOrdinal! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 4/26/2008 23:50'!
reactToClass: aChunk
	(element theClassName = aChunk name and: [aChunk isRemoval])
		ifTrue: [self beInvisible].
	^ aChunk! !

!MDChunk methodsFor: 'operations' stamp: 'cwp 4/27/2008 00:05'!
remove
	properties := nil! !

!MDChunk methodsFor: 'initialize-release' stamp: 'cwp 4/27/2008 00:29'!
setElement: anElement
	invisible := false.
	element := anElement.! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 5/20/2008 22:38'!
sortKey
	^ String streamContents: [ :stream | self printSortKeyOn: stream ]! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 5/20/2008 22:41'!
sortOrdinal
	^ element name! !

!MDChunk methodsFor: 'accessing' stamp: 'cwp 11/18/2008 20:00'!
theClassName
	^ element theClassName! !

!MDChunk methodsFor: 'writing' stamp: 'cwp 5/19/2008 00:29'!
writeInitializerOn: aStream
	! !

!MDChunk methodsFor: 'writing' stamp: 'cwp 4/27/2008 00:31'!
writeOn: aStream
	invisible ifFalse:
		[properties
			ifNil: [self writeRemovalOn: aStream]
			ifNotNil: [self writeDefinitionOn: aStream]]! !

!MDChunk methodsFor: 'writing' stamp: 'cwp 8/12/2008 20:28'!
writeStampOn: aStream 
	((properties includesKey: #initials) and: [ properties includesKey: #timeStamp ]) ifTrue: 
		[ aStream
			nextPutAll: ''' stamp: ''';
			nextPutAll: properties initials;
			space.
		properties timeStamp printer 
			printOn: aStream
			format: '%l/%e/%Y %H:%M' ]! !

MDChunk subclass: #MDClassChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDClassChunk class methodsFor: 'as yet unclassified' stamp: 'cwp 3/25/2008 00:19'!
forElement: anElement
	^ self new setElement: anElement! !

!MDClassChunk methodsFor: 'writing' stamp: 'cwp 5/22/2008 00:11'!
formatKeyword
	| format |
	format := properties format.
	format = #normal ifTrue: [^ 'subclass:'].
	format = #bytes ifTrue: [^ 'variableByteSubclass:'].
	format = #variable ifTrue: [^ 'variableSubclass:'].
	format = #words ifTrue: [^ 'variableWordSubclass:'].
	format = #weak ifTrue: [^ 'weakSubclass:'].
	self error: 'Unrecognized format'! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 5/19/2008 01:09'!
hasSuperclass: aSymbol
	^ properties
		ifNil: [false]
		ifNotNil: [properties superclassName = aSymbol]! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 5/2/2008 23:00'!
isSuperOf: aChunk
	^ aChunk hasSuperclass: element theClassName! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 4/26/2008 20:33'!
name
	^ element theClassName! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 4/26/2008 20:32'!
reactToClass: aSymbol
	^ self! !

!MDClassChunk methodsFor: 'harmonizing' stamp: 'cwp 3/30/2008 23:48'!
typeChar
	^ $a! !

!MDClassChunk methodsFor: 'writing' stamp: 'cwp 3/28/2008 00:17'!
writeDefinitionOn: aStream
	aStream 
		nextPutAll: properties superclassName;
		space;
		nextPutAll: self formatKeyword;
		space;
		print: element theClassName;
		crtab;
		nextPutAll: 'instanceVariableNames: ''''';
		crtab;
		nextPutAll: 'classVariableNames: ''''';
		crtab;
		nextPutAll: 'poolDictionaries: ''''';
		crtab;
		nextPutAll: 'category: ';
		nextPut: $';
		nextPutAll: properties category;
		nextPut: $';
		nextPut: $!!;
		cr! !

!MDClassChunk methodsFor: 'writing' stamp: 'cwp 3/28/2008 00:18'!
writeRemovalOn: aStream
	aStream 
		nextPutAll: 'Smalltalk removeClassNamed: #';
		nextPutAll: element theClassName;
		nextPut: $!!;
		cr! !

MDChunk subclass: #MDClassCommentChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDClassCommentChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:48'!
typeChar
	^ $b! !

!MDClassCommentChunk methodsFor: 'as yet unclassified' stamp: 'cwp 7/2/2008 23:06'!
writeDefinitionOn: aStream
	aStream
		nextPut: $!!;
		nextPutAll: element theClassName;
		nextPutAll: ' commentStamp: ''';
		nextPutAll: (properties initials ifNil: ['<unknown author>']);
		space.
	properties timeStamp ifNotNilDo:
		[:stamp | stamp printer printOn: aStream format: '%l/%e/%Y %H:%M'].
	aStream
		nextPutAll: ''' prior: 0!!';
		cr.
	properties text do:
		[:ch |
		aStream nextPut: ch.
		ch = $!! ifTrue: [aStream nextPut: $!!]].
	aStream
		nextPut: $!!;
		cr! !

!MDClassCommentChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 23:37'!
writeRemovalOn: aStream
	aStream
		nextPut: $!!;
		nextPutAll: element theClassName;
		nextPutAll: ' classComment: nil stamp: nil!!';
		cr! !

MDChunk subclass: #MDMethodChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:55'!
typeChar
	^ element classIsMeta
		ifTrue: [$h]
		ifFalse: [$f]! !

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 01:08'!
writeDefinitionOn: aStream 
	aStream
		nextPut: $!!;
		nextPutAll: element theClassName.
	element classIsMeta ifTrue: [ aStream nextPutAll: ' class' ].
	aStream
		space;
		nextPutAll: 'methodsFor: ''';
		nextPutAll: properties category.
	self writeStampOn: aStream.
	aStream
		nextPutAll: '''!!';
		cr.
	properties source do:
		[:ch |
		aStream nextPut: ch.
		ch = $!! ifTrue: [aStream nextPut: $!!]].
	aStream
		nextPutAll: '!! !!';
		cr! !

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:40'!
writeInitializerOn: aStream
	(element classIsMeta and: [element selector = #initialize]) ifTrue:
		[aStream 
			nextPutAll: element theClassName;
			space;
			nextPutAll: 'initialize!!';
			cr;
			cr]! !

!MDMethodChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:03'!
writeRemovalOn: aStream
	aStream nextPutAll: element theClassName.
	element classIsMeta ifTrue: [aStream nextPutAll: ' class'].
	aStream 
		nextPutAll: ' removeSelector: #';
		nextPutAll: element selector;
		nextPut: $!!;
		cr! !

MDChunk subclass: #MDNullChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDNullChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:39'!
sortKey
	^ ''! !

!MDNullChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 00:10'!
writeOn: aStream! !

MDChunk subclass: #MDVariableChunk
	instanceVariableNames: 'independent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

MDVariableChunk subclass: #MDClassInstVarChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:20'!
classReference
	^ element theClassName, ' class'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:29'!
definitionSelector
	^ 'class addInstVarName:'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:15'!
listSelector
	^ 'instVarNames'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:35'!
removalSelector
	^ 'class removeInstVarName:'! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 5/20/2008 23:02'!
sortOrdinal
	^ properties index printString! !

!MDClassInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:52'!
typeChar
	^ $g! !

MDVariableChunk subclass: #MDClassVarChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:14'!
definitionSelector
	^ 'addClassVarName:'! !

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:21'!
listSelector
	^ 'classVarNames'! !

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:15'!
removalSelector
	^ 'removeClassVarName:'! !

!MDClassVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:51'!
typeChar
	^ $d! !

MDVariableChunk subclass: #MDInstVarChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:15'!
definitionSelector
	^ 'addInstVarName:'! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 00:22'!
listSelector
	^ 'instVarNames'! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 22:16'!
removalSelector
	^ 'removeInstVarName:'! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 5/20/2008 22:50'!
sortOrdinal
	^ properties index printString! !

!MDInstVarChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:48'!
typeChar
	^ $c! !

MDVariableChunk subclass: #MDPoolImportChunk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:48'!
definitionSelector
	^ 'addSharedPool:'! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:48'!
listSelector
	^ 'sharedPools'! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:55'!
quote
	^ ''! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:28'!
removalSelector
	^ 'removeSharedPool:'! !

!MDPoolImportChunk methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:52'!
typeChar
	^ $e! !

!MDVariableChunk methodsFor: 'accessing' stamp: 'cwp 4/3/2008 22:26'!
beDependent
	independent := false! !

!MDVariableChunk methodsFor: 'accessing' stamp: 'cwp 4/3/2008 22:26'!
beIndependent
	independent := true! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:31'!
classReference
	^ element theClassName! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
conditional
	^ properties
		ifNil: ['ifTrue:']
		ifNotNil: ['ifFalse:']! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
definitionSelector
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
listSelector
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
quote
	^ ''''! !

!MDVariableChunk methodsFor: 'accessing' stamp: 'cwp 4/27/2008 00:40'!
reactToClass: aChunk
	element theClassName = aChunk name ifTrue: 
		[aChunk isRemoval
			ifTrue: [self beInvisible]
			ifFalse: [self beDependent]].
	^ aChunk! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
removalSelector
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'initialize-release' stamp: 'cwp 4/3/2008 22:28'!
setElement: anElement
	super setElement: anElement.
	independent := true! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:24'!
typeChar
	self subclassResponsibility! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeBasicDefinitionOn: aStream 
	aStream
		nextPutAll: element theClassName;
		space;
		nextPutAll: self definitionSelector;
		space;
		nextPutAll: self quote;
		nextPutAll: element name;
		nextPutAll: self quote! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeBasicRemovalOn: aStream 
	aStream
		nextPutAll: element theClassName;
		space;
		nextPutAll: self removalSelector;
		space;
		nextPutAll: self quote;
		nextPutAll: element name;
		nextPutAll: self quote! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeClassCheckOn: aStream with: aBlock
	independent ifFalse: aBlock ifTrue: 
		[aStream
			nextPutAll: '(Smalltalk hasClassNamed: #';
			nextPutAll: element theClassName;
			nextPutAll: ') ifTrue:';
			crtab;
			nextPut: $[.
		aBlock value.
		aStream
			nextPut: $]].
	aStream 
		nextPut: $!!; 
		cr! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeDefinitionOn: aStream 
	self 
		writeClassCheckOn: aStream
		with: 
			[ self 
				writeGuardOn: aStream
				with: [ self writeBasicDefinitionOn: aStream ] ]! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:30'!
writeGuardOn: aStream with: aBlock
	aStream
		nextPut: $(;
		nextPutAll: self classReference;
		space;
		nextPutAll: self listSelector;
		nextPutAll: ' includes: ';
		nextPutAll: self quote;
		nextPutAll: element name;
		nextPutAll: self quote;
		nextPutAll: ') ';
		nextPutAll: self conditional;
		crtab.
	independent ifTrue: [aStream tab].
	aStream nextPut: $[.
	aBlock value.
	aStream nextPut: $]! !

!MDVariableChunk methodsFor: 'writing' stamp: 'cwp 4/3/2008 22:29'!
writeRemovalOn: aStream 
	self 
		writeClassCheckOn: aStream
		with: 
			[ self 
				writeGuardOn: aStream
				with: [ self writeBasicRemovalOn: aStream ] ]! !

Object subclass: #MDFakeLink
	instanceVariableNames: 'service closed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDFakeLink class methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
repositoryForTesting
	| service link repository |
	service := MDNetService for: MDMemoryRepository new.
	link := MDFakeLink to: service.
	repository := MDNetRepository link: link.
	^ repository! !

!MDFakeLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 23:58'!
to: aService
	^ self new setService: aService! !

!MDFakeLink methodsFor: 'accessing' stamp: 'jf 10/25/2008 13:35'!
close
	closed := true! !

!MDFakeLink methodsFor: 'accessing' stamp: 'cwp 1/5/2008 00:10'!
description
	^ 'fake net repository'! !

!MDFakeLink methodsFor: 'testing' stamp: 'jf 10/25/2008 13:36'!
isOpen
	^ closed isNil or: [ closed not ]! !

!MDFakeLink methodsFor: 'accessing' stamp: 'cwp 6/1/2008 00:55'!
locator
	^ MDFakeLocator new! !

!MDFakeLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 23:58'!
send: aMessage
	^ service handleMessage: aMessage! !

!MDFakeLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setService: aService
	service := aService! !

Object subclass: #MDFakeLocator
	instanceVariableNames: 'stream mocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDFakeLocator methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
createStream
	| class |
	class := Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream].
	stream := class on: self mocket.
	^ stream! !

!MDFakeLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:03'!
description
	^ 'Fake'! !

!MDFakeLocator methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2008 00:34'!
host
	^ 'fakehost.com'! !

!MDFakeLocator methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
mocket
	
	^ mocket ifNil: 
		[mocket := MLMocket new.
		mocket
			execute: [mocket connectTo: #(127 0 0 1) port: 7301];
			expectConnectionTo: #(127 0 0 1) port: 7301]! !

!MDFakeLocator methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2008 00:36'!
port
	^ 7901! !

!MDFakeLocator methodsFor: 'as yet unclassified' stamp: 'cwp 6/1/2008 00:56'!
update: properties
	^ properties
		type: MDNetRepository type;
		host: self host;
		port: self port;
		yourself! !

Object subclass: #MDFileOutExporter
	instanceVariableNames: 'stream sections preamble'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDFileOutExporter class methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:16'!
on: aStream
	^ self new setStream: aStream! !

!MDFileOutExporter methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2009 22:39'!
adapt: anElement
	^ anElement handleWith: (MDChunkHandler exporter: self)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForClassCommentElement: anElement 
	^ self addChunk: (MDClassCommentChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForClassElement: anElement 
	^ self addChunk: (MDClassChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForClassInstVarElement: anElement 
	^ self addChunk: (MDClassInstVarChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForClassVarElement: anElement 
	^ self addChunk: (MDClassVarChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForInstVarElement: anElement 
	^ self addChunk: (MDInstVarChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForMethodElement: anElement 
	^ self addChunk: (MDMethodChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'adapting' stamp: 'cwp 5/2/2008 21:23'!
adaptorForPoolImportElement: anElement 
	^ self addChunk: (MDPoolImportChunk forElement: anElement)! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 21:43'!
addChunk: aChunk 
	aChunk joinSectionIn: sections.
	^ aChunk! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 22:35'!
addMemo: aMemo 
	preamble := MDMemoChunk on: aMemo.! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 21:19'!
addVersion: aVersion
	aVersion variant loadInto: self! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 21:19'!
export: aMemo from: aRepository
	| snapshot |
	self addMemo: aMemo.
	snapshot := aRepository get: aMemo reference.
	snapshot contents do:
		[:ea | self addVersion: (aRepository get: ea)].
	self harmonize.
	self flush! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/19/2008 00:44'!
flush
	preamble ifNotNil: 
		[preamble writeOn: stream.
		stream cr].
	sections 
		do:	[:ea | 
			ea writeOn: stream. 
			stream cr].
	sections do: [:ea | ea writeInitializerOn: stream].
	stream flush! !

!MDFileOutExporter methodsFor: 'exporting' stamp: 'cwp 5/2/2008 22:46'!
harmonize
	sections do: [:ea | ea harmonize].
	sections do: 
		[:outer | 
		sections do: 
			[:inner | 
			outer noteSection: inner]].
	sections := sections asSortedCollection.! !

!MDFileOutExporter methodsFor: 'initialize-release' stamp: 'cwp 5/2/2008 21:30'!
setStream: aStream
	stream := aStream.
	sections := Dictionary new.! !

Object subclass: #MDFileOutSection
	instanceVariableNames: 'chunks superSection depth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDFileOutSection class methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2008 18:49'!
new
	^ self basicNew initialize! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 10/13/2008 16:22'!
<= other
	^ self isSharedPool = other isSharedPool
		ifFalse: [self isSharedPool]
		ifTrue: 
			[self depth = other depth
				ifTrue: [self theClassName <= other theClassName]
				ifFalse: [self depth < other depth]]
! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:29'!
addChunk: aChunk
	chunks add: aChunk! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 22:30'!
classChunk
	^ chunks first! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 23:01'!
depth
	^ depth ifNil:
		[depth := superSection 
			ifNil: [1]
			ifNotNil: [superSection depth + 1]]! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:31'!
harmonize
	| class |
	chunks := chunks asSortedCollection: [ :a :b | a sortKey <= b sortKey ].
	class := nil.
	chunks do: [ :chunk | class := chunk reactToClass: class ]! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:29'!
initialize
	chunks := Set new! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 10/13/2008 16:32'!
isSharedPool
	^ self classChunk hasSuperclass: #SharedPool! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 22:30'!
noteSection: other
	(other classChunk isSuperOf: self classChunk) ifTrue:
		[superSection := other]! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 11/18/2008 20:00'!
theClassName
	^ chunks first theClassName! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:39'!
writeInitializerOn: aStream
	chunks do: [:ea | ea writeInitializerOn: aStream]
		! !

!MDFileOutSection methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:34'!
writeOn: aStream
	chunks
		do: [:ea | ea writeOn: aStream]
		separatedBy: [aStream cr]! !

Object subclass: #MDKeyedStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-File'!

!MDKeyedStream class methodsFor: 'as yet unclassified' stamp: 'avi 4/17/2005 01:19'!
on: aStream
	^ self basicNew initializeWithStream: aStream! !

!MDKeyedStream methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
= other
	^ self species = other species
		and: [self stream name = other stream name]! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 11/6/2007 22:52'!
appendKey: keyBytes value: valueBytes 
	self assert: [keyBytes size = self keySize].
	stream
		setToEnd;
		nextPutAll: keyBytes;
		nextInt32Put: valueBytes size;
		nextPutAll: valueBytes! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 10/13/2005 23:00'!
close
	stream name = 'a stream' ifFalse: [stream close]! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:58'!
flush
	stream flush! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/19/2005 01:49'!
fromPosition: aNumber keysValuesAndPositionsDo: aBlock 
	| position key |
	stream position: aNumber.
	[stream atEnd] whileFalse: 
			[key := stream next: self keySize.
			position := stream position.
			aBlock
				value: key
				value: self readValue
				value: position]! !

!MDKeyedStream methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
hash
	^ self stream name hash! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 5/22/2008 00:11'!
initializeWithStream: aPositionableStream
	stream := aPositionableStream.
	stream binary! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 15:14'!
keySize
	^ 24! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 02:11'!
keysValuesAndPositionsDo: aBlock 
	self fromPosition: 0 keysValuesAndPositionsDo: aBlock
			! !

!MDKeyedStream methodsFor: 'public' stamp: 'avi 4/17/2005 01:38'!
nextValuePosition
	^ stream size + self keySize! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 4/10/2005 17:29'!
position
	^ stream position! !

!MDKeyedStream methodsFor: 'private' stamp: 'cwp 10/22/2008 20:44'!
readValue
	| length |
	[length := stream nextInt32]
		on: Error
		do: [:error | ^ nil].
	^ stream next: length.
	! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'avi 3/22/2006 19:23'!
reopen
	stream name = 'a stream' ifFalse: [stream reopen; binary]! !

!MDKeyedStream methodsFor: 'accessing' stamp: 'cwp 4/10/2005 14:53'!
stream
	^ stream! !

!MDKeyedStream methodsFor: 'public' stamp: 'cwp 10/31/2008 23:49'!
valueAtPosition: anInteger
	[stream position: anInteger]
		on: Error
		do: [:err | ^ nil].
	^ self readValue! !

Object subclass: #MDMemoChunk
	instanceVariableNames: 'memo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-FileOut'!

!MDMemoChunk class methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:19'!
on: aMemo
	^ self new setMemo: aMemo! !

!MDMemoChunk methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setMemo: aMemo
	memo := aMemo! !

!MDMemoChunk methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 01:00'!
writeOn: aStream
	aStream 
		nextPut: $";
		nextPutAll: memo name;
		cr.
	memo description do:
		[:ch | 
		aStream nextPut: ch. 
		ch = $" ifTrue: [aStream nextPut: $"].
		ch = $!! ifTrue: [aStream nextPut: $!!]].
	aStream
		nextPutAll: '"!!';
		cr! !

Object subclass: #MDMockLink
	instanceVariableNames: 'injected expected open'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDMockLink class methodsFor: 'as yet unclassified' stamp: 'cwp 11/20/2008 18:51'!
new
	^ self basicNew initialize! !

!MDMockLink methodsFor: 'asserting' stamp: 'cwp 1/4/2008 12:32'!
assert: actual matches: expectation
	actual = expectation ifFalse: [TestFailure signal: 'Unexpected message']! !

!MDMockLink methodsFor: 'open/close' stamp: 'cwp 5/22/2008 00:11'!
close
	open := false! !

!MDMockLink methodsFor: 'accessing' stamp: 'cwp 1/4/2008 14:19'!
description
	^ 'Mock'! !

!MDMockLink methodsFor: 'asserting' stamp: 'cwp 1/4/2008 12:26'!
expect: aMessage
	expected add: aMessage! !

!MDMockLink methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:11'!
initialize
	injected := OrderedCollection new.
	expected := OrderedCollection new.
	open := false! !

!MDMockLink methodsFor: 'asserting' stamp: 'cwp 1/4/2008 12:25'!
inject: aMessage
	injected add: aMessage! !

!MDMockLink methodsFor: 'open/close' stamp: 'cwp 1/4/2008 12:33'!
isOpen
	^ open! !

!MDMockLink methodsFor: 'accessing' stamp: 'cwp 6/5/2008 07:17'!
locator
	^ MDNetLocator host: 'example.com' port: 7901! !

!MDMockLink methodsFor: 'open/close' stamp: 'cwp 5/22/2008 00:11'!
open
	open := true! !

!MDMockLink methodsFor: 'sending' stamp: 'cwp 1/4/2008 12:31'!
send: aMessage
	self assert: aMessage matches: expected removeFirst.
	^ injected removeFirst! !

Object subclass: #MDNetLink
	instanceVariableNames: 'locator stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 13:09'!
host: aString
	^ self locator: (MDNetLocator host: aString)! !

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:40'!
host: aString port: anInteger
	^ self locator: (MDNetLocator host: aString port: anInteger)! !

!MDNetLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 14:49'!
locator: aLocator
	^ self new setLocator: aLocator! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 12:38'!
close
	stream close.
	! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:04'!
description
	^ locator description! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/12/2008 13:10'!
isOpen
	^ stream notNil and: [stream isConnected]! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/9/2008 16:03'!
locator
	^ locator! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
open
	stream := locator createStream.
	! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:44'!
send: aMessage
	self isOpen ifFalse: [self error: 'Link is not open'].
	aMessage writeOn: stream.
	stream flush.
	^ MDNetMessage readFrom: stream! !

!MDNetLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setLocator: aLocator
	locator := aLocator! !

Object subclass: #MDNetListener
	instanceVariableNames: 'repository port socket process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetListener class methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
repository: aRepository startOn: anInteger
	| listener |
	listener := self new setRepository: aRepository port: anInteger.
	listener start.
	^ listener! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:23'!
name
	^ '[', repository description, ']'! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
run
	| connection |
	[socket isValid] whileTrue:
		[connection := socket waitForAcceptFor: 10 ifTimedOut: [nil].
		connection ifNotNil: [MDServerLink 
								serve: connection 
								repository: repository]]
			! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setRepository: aRepository port: anInteger
	repository := aRepository.
	port := anInteger.
	! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
start
	socket := Socket newTCP.
	socket listenOn: port backlogSize: 10.
	process := [self run] 
				forkAt: Processor systemBackgroundPriority  
				named: self name
	! !

!MDNetListener methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:09'!
stop
	socket closeAndDestroy! !

Object subclass: #MDNetLocator
	instanceVariableNames: 'host port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetLocator class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:31'!
host: aString 
	^ self host: aString port: nil! !

!MDNetLocator class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:29'!
host: aString port: anInteger
	^ self new setHost: aString port: anInteger! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
createStream
	| class stream |
	class := Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream].
	stream := class openConnectionToHostNamed: self host port: self port.
	stream binary.
	^ stream! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
defaultPort
	^ 6101! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
description
	^ String streamContents: 
		[:stream |
		stream nextPutAll: host.
		port ifNotNil:
			[stream 
				nextPut: $:; 
				print: port]]! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
host
	^ host! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 21:32'!
port
	^ port ifNil: [self defaultPort]! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setHost: aString port: anInteger
	host := aString.
	port := anInteger! !

!MDNetLocator methodsFor: 'as yet unclassified' stamp: 'cwp 6/5/2008 21:43'!
update: properties
	^ properties
		host: self host;
		port: self port;
		yourself! !

Object subclass: #MDNetMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDNetMessage subclass: #MDEmptyMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDEmptyMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:05'!
readContentsFrom: aStream
	^ self new! !

!MDEmptyMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:04'!
= other
	^ self species = other species! !

!MDEmptyMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:04'!
hash
	^ self species hash! !

MDEmptyMessage subclass: #MDGetHashstamps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDGetHashstamps class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:02'!
id
	^ 68! !

!MDGetHashstamps methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:42'!
handledBy: anObject
	^ anObject handleGetHashstamps: self! !

MDEmptyMessage subclass: #MDGetMemos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDGetMemos class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 67! !

!MDGetMemos methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:11'!
handledBy: anObject
	^ anObject handleGetMemos: self! !

MDNetMessage subclass: #MDErrorMessage
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDErrorMessage subclass: #MDAuthenticationFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDAuthenticationFailed class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:30'!
id
	^ 193! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:26'!
= other
	^ self species = other species and: [self description = other description]! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:54'!
checkForError
	MDPeerError signal: description! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:29'!
description
	^ description! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:27'!
hash
	^ description hash! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:53'!
isError
	^ true! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setContents: aString
	description := aString! !

!MDErrorMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:28'!
writeContentsOn: aStream
	MDMarshal serialize: description on: aStream! !

MDErrorMessage subclass: #MDObjectNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDObjectNotFound class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:34'!
id
	^ 195! !

MDErrorMessage subclass: #MDProcessingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDErrorMessage subclass: #MDStorageFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDStorageFailed class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:34'!
id
	^ 196! !

MDErrorMessage subclass: #MDUnauthorized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDUnauthorized class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:32'!
id
	^ 194! !

MDErrorMessage subclass: #MDUnrecognizedMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDUnrecognizedMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:27'!
id
	^ 192! !

MDNetMessage subclass: #MDHashstampMessage
	instanceVariableNames: 'hashstamps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDHashstampMessage subclass: #MDAllHashstamps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDAllHashstamps class methodsFor: 'as yet unclassified' stamp: 'cwp 1/8/2008 18:36'!
id
	^ 132! !

MDHashstampMessage subclass: #MDGetObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDGetObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 64! !

!MDGetObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:28'!
handledBy: aService
	^ aService handleGet: self! !

!MDHashstampMessage methodsFor: 'comparing' stamp: 'cwp 1/4/2008 00:02'!
= other
	^ self species = other species and: [self hashstamps = other hashstamps]! !

!MDHashstampMessage methodsFor: 'comparing' stamp: 'cwp 1/4/2008 00:02'!
hash
	^ hashstamps hash! !

!MDHashstampMessage methodsFor: 'accessing' stamp: 'cwp 1/4/2008 00:02'!
hashstamps
	^ hashstamps! !

!MDHashstampMessage methodsFor: 'intialize-release' stamp: 'cwp 5/22/2008 00:11'!
setContents: aCollection
	hashstamps := aCollection asSet! !

!MDHashstampMessage methodsFor: 'writing' stamp: 'cwp 1/4/2008 00:02'!
writeContentsOn: aStream
	MDMarshal serialize: hashstamps on: aStream! !

MDHashstampMessage subclass: #MDOfferObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDOfferObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 65! !

!MDOfferObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:14'!
withObjects: aCollection
	^ self with: (aCollection collect: [:ea | ea hashstamp])! !

!MDOfferObjects methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:19'!
handledBy: anObject
	^ anObject handleOfferObjects: self! !

MDHashstampMessage subclass: #MDRequestObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDRequestObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:43'!
id
	^ 129! !

!MDRequestObjects methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
filter: aCollection in: aBlock
	| selected |
	selected := aCollection select: [:ea | hashstamps includes: ea hashstamp].
	selected isEmpty ifFalse: [aBlock value: (MDPutObjects with: selected)]! !

!MDRequestObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:00'!
isRequestObjects
	^ true! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:04'!
fromBytes: aByteArray
	^ self readFrom: aByteArray readStream! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:15'!
id
	self subclassResponsibility! !

!MDNetMessage class methodsFor: 'testing' stamp: 'cwp 1/4/2008 00:17'!
isConcrete
	^ self class includesSelector: #id! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/4/2008 00:17'!
messageClassWithId: anInteger
	^ self allSubclasses 
		detect: [:ea | ea isConcrete and: [ea id = anInteger]]
		ifNone: [self messageIdNotFound: anInteger]! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:58'!
messageClasses
	^ self allSubclasses select: [:ea | ea class includesSelector: #id]! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:12'!
messageIdNotFound: id
	^ self error: 'Message ', id asString, ' not understood'! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 1/3/2008 23:27'!
readContentsFrom: aStream
	^ self with: (MDMarshal materializeFrom: aStream)! !

!MDNetMessage class methodsFor: 'reading' stamp: 'cwp 5/22/2008 00:11'!
readFrom: aStream
	| class |
	class := self messageClassWithId: aStream next.
	^ class readContentsFrom: aStream! !

!MDNetMessage class methodsFor: 'instance creation' stamp: 'cwp 1/3/2008 23:23'!
with: aSet
	^ self new setContents: aSet! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 21:06'!
assertMessageIs: aClass
	(self isKindOf: aClass) ifFalse: [MDProtocolError signal]! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:05'!
bytes
	^ ByteArray streamContents: [:stream | self writeOn: stream]! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 19:54'!
checkForError
	! !

!MDNetMessage methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:15'!
id
	^ self class id! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 19:53'!
isError
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 14:17'!
isGoodbye
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:36'!
isHello
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 14:24'!
isMemos
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:39'!
isObjects
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 21:01'!
isRequestObjects
	^ false! !

!MDNetMessage methodsFor: 'testing' stamp: 'cwp 1/4/2008 20:57'!
isThankYou
	^ false! !

!MDNetMessage methodsFor: 'intialize-release' stamp: 'cwp 1/3/2008 23:23'!
setContents: anObject
	self subclassResponsibility! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:32'!
writeContentsOn: aStream
	! !

!MDNetMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:08'!
writeOn: aStream
	aStream nextPut: self id.
	self writeContentsOn: aStream! !

MDNetMessage subclass: #MDObjectsMessage
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDObjectsMessage subclass: #MDMemos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDMemos class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:45'!
id
	^ 131! !

!MDMemos methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:24'!
isMemos
	^ true! !

MDObjectsMessage subclass: #MDObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:45'!
id
	^ 128! !

!MDObjects methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:39'!
isObjects
	^ true! !

!MDObjectsMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 1/3/2008 23:14'!
readContentsFrom: aStream
	^ self with: (MDMarshal materializeFrom: aStream)! !

!MDObjectsMessage methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:17'!
= other
	^ self species = other species
		and: [objects = other objects]! !

!MDObjectsMessage methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:17'!
hash
	^ objects hash! !

!MDObjectsMessage methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:17'!
objects
	^ objects! !

!MDObjectsMessage methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:11'!
setContents: aCollection
	objects := aCollection asSet! !

!MDObjectsMessage methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:08'!
writeContentsOn: aStream
	MDMarshal serialize: objects on: aStream! !

MDObjectsMessage subclass: #MDPutObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDPutObjects class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 66! !

!MDPutObjects methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:16'!
handledBy: anObject
	^ anObject handlePutObjects: self! !

MDNetMessage subclass: #MDSalutationMessage
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDSalutationMessage subclass: #MDGoodbye
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDGoodbye class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:40'!
id
	^ 2! !

!MDGoodbye methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:25'!
handledBy: anObject
	^ anObject handleGoodbye: anObject! !

!MDGoodbye methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 14:17'!
isGoodbye
	^ true! !

MDSalutationMessage subclass: #MDHello
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDHello class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
id
	^ 1! !

!MDHello methodsFor: 'dispatch' stamp: 'cwp 1/4/2008 22:08'!
handledBy: anObject
	^ anObject handleHello: self! !

!MDHello methodsFor: 'testing' stamp: 'cwp 1/4/2008 12:36'!
isHello
	^ true! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
= other
	^ self species = other species and: [self description = other description]! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:32'!
defaultDescription
	^ NetNameResolver localHostName! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:30'!
description
	^ description ifNil: [self defaultDescription]! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 00:39'!
hash
	^ description hash! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setContents: aString
	description := aString! !

!MDSalutationMessage methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:29'!
writeContentsOn: aStream
	MDMarshal serialize: self description on: aStream! !

MDNetMessage subclass: #MDThankYou
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDThankYou class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 19:44'!
id
	^ 130! !

!MDThankYou methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:52'!
= other
	^ self species = other species and: [self count = other count]! !

!MDThankYou methodsFor: 'accessing' stamp: 'cwp 1/3/2008 23:52'!
count
	^ count! !

!MDThankYou methodsFor: 'comparing' stamp: 'cwp 1/3/2008 23:52'!
hash
	^ count hash! !

!MDThankYou methodsFor: 'writing' stamp: 'cwp 1/4/2008 20:58'!
isThankYou
	^ true! !

!MDThankYou methodsFor: 'intialize-release' stamp: 'cwp 5/22/2008 00:11'!
setContents: anInteger
	count := anInteger! !

!MDThankYou methodsFor: 'writing' stamp: 'cwp 1/3/2008 23:51'!
writeContentsOn: aStream
	MDMarshal serialize: count on: aStream! !

Object subclass: #MDNetService
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetService class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 21:22'!
for: aRepository
	^ self new setRepository: aRepository! !

!MDNetService methodsFor: 'public' stamp: 'cwp 1/19/2008 01:32'!
description
	^ repository description! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 21:27'!
handleGet: message
	^ MDObjects with: (repository getAll: message hashstamps)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/8/2008 18:43'!
handleGetHashstamps: message
	^ MDAllHashstamps with: (repository allHashstamps)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:12'!
handleGetMemos: message
	^ MDMemos with: (repository memos)! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:26'!
handleGoodbye: message
	^ MDGoodbye new! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:08'!
handleHello: message
	^ MDHello new! !

!MDNetService methodsFor: 'public' stamp: 'cwp 1/4/2008 22:43'!
handleMessage: aMessage
	^ [aMessage handledBy: self]
		on: Error
		do: [:err | MDProcessingError with: err description]! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 5/22/2008 00:11'!
handleOfferObjects: message
	| wanted |
	wanted := repository selectFrom: message hashstamps.
	^ MDRequestObjects with: wanted! !

!MDNetService methodsFor: 'message handlers' stamp: 'cwp 1/4/2008 22:34'!
handlePutObjects: message

	^ 	[repository putAll: message objects.
		MDThankYou with: message objects size]
			on: Error
			do: [:err | MDStorageFailed with: err description]! !

!MDNetService methodsFor: 'initialize-release' stamp: 'cwp 5/22/2008 00:11'!
setRepository: aRepository
	repository := aRepository! !

Object subclass: #MDServerLink
	instanceVariableNames: 'stream service process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDServerLink class methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
serve: aSocket repository: aRepository
	| link |
	link := self socket: aSocket repository: aRepository.
	link start! !

!MDServerLink class methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:16'!
socket: aSocket repository: aRepository
	^ self new setSocket: aSocket repository: aRepository! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
handleMessage
	|  request response |
	[request := MDNetMessage readFrom: stream]
		on: ConnectionClosed, ConnectionTimedOut 
		do: [:exception | ^ nil].
	response := service handleMessage: request.
	response writeOn: stream.
	stream flush.
	response isGoodbye ifTrue: [stream close]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 01:32'!
name
	^ String streamContents:
		[:out |
		out 
			nextPutAll: stream socket remoteAddress asString;
			nextPutAll: '->';
			nextPutAll: service description]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/19/2008 01:16'!
run
	[stream isConnected] whileTrue: [self handleMessage]! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setSocket: aSocket repository: aRepository
	stream := self streamClass on: aSocket.
	service := MDNetService for: aRepository.
	stream binary! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
start
	process := [self run] 
				forkAt: Processor highIOPriority 
				named: self name
! !

!MDServerLink methodsFor: 'as yet unclassified' stamp: 'cwp 1/18/2008 23:18'!
streamClass
	^ Smalltalk at: #FastSocketStream ifAbsent: [Smalltalk at: #SocketStream]! !

TestCase subclass: #MDByteIndexTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDByteIndexTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
storeAndRetrieveWithFileSize: aNumber
	|  file stream |
	stream := RWBinaryOrTextStream on: ByteArray new.
	stream next: aNumber put: 0.
	stream reset.
 
	file := MDByteIndex stream: stream keySize: 2 valueSize: 4.
	file at: 'aa' asByteArray put: 'abcd' asByteArray.
	file at: 'ab' asByteArray put: 'qxry' asByteArray.
	file at: 'xy' asByteArray put: '1234' asByteArray.
	self assert: file tally = 3.

	self assert: (file at: 'aa' asByteArray) = 'abcd' asByteArray.
	self assert: (file at: 'ab' asByteArray) = 'qxry' asByteArray.
	self assert: (file at: 'xy' asByteArray) = '1234' asByteArray.
	file at: 'ab' asByteArray put: '9876' asByteArray.
	self assert: (file at: 'ab' asByteArray) = '9876' asByteArray.
	self assert: file tally = 3! !

!MDByteIndexTest methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2005 03:58'!
testStoreAndRetrieve
	self storeAndRetrieveWithFileSize: 100.
	self storeAndRetrieveWithFileSize: 24.
	self should: [self storeAndRetrieveWithFileSize: 12] raise: Error! !

TestCase subclass: #MDChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDChunkTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:31'!
isAbstract
	^ self name = #MDChunkTest! !

!MDChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
write: aChunk
	| stream |
	stream := WriteStream on: String new.
	aChunk writeOn: stream.
	^ stream contents.
! !

MDChunkTest subclass: #MDClassChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionA
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #normal;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionB
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusB).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #normal;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object subclass: #BogusB
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionBytes
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #bytes;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object variableByteSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionCategory
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Griffle';
					format: #normal;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Griffle''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionSuperclass
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #normal;
					superclassName: #String;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'String subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionVariable
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #variable;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object variableSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionWeak
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #weak;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object weakSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:41'!
testDefinitionWords
	| chunk properties result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	properties := MDPropertyDictionary new
					category: #'Bogus-Base';
					format: #words;
					superclassName: #Object;
					yourself.
	chunk load: properties.
	result := self write: chunk.
	self assert: result = 'Object variableWordSubclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!
'! !

!MDClassChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testRemoval
	| chunk result |
	chunk := MDClassChunk forElement: (MDClassElement className: #BogusA).
	chunk remove.
	result := self write: chunk.
	self assert: result = 'Smalltalk removeClassNamed: #BogusA!!
'! !

MDChunkTest subclass: #MDClassCommentChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:43'!
testClassIsRemoved
	| chunk actual class |
	class := MDClassChunk forElement: (MDClassElement className: #BogusA).
	class remove.
	chunk := MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	chunk load: MDPropertyDictionary new.
	chunk reactToClass: class.
	actual := self write: chunk.
	self assert: actual isEmpty! !

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionWithBang
	| chunk properties actual |
	chunk := MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	properties := MDPropertyDictionary new
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					text: 'Comment!! for BogusA'
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	self assert: actual =  '!!BogusA commentStamp: ''cwp 3/28/2008 23:18'' prior: 0!!
Comment!!!! for BogusA!!
'! !

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionWithStamp
	| chunk properties actual |
	chunk := MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	properties := MDPropertyDictionary new
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					text: 'Comment for BogusA'
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	self assert: actual =  '!!BogusA commentStamp: ''cwp 3/28/2008 23:18'' prior: 0!!
Comment for BogusA!!
'! !

!MDClassCommentChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testRemoval
	| chunk actual |
	chunk := MDClassCommentChunk forElement: (MDClassCommentElement className: #BogusA).
	chunk remove.
	actual := self write: chunk.
	self assert: actual =  '!!BogusA classComment: nil stamp: nil!!
'! !

MDChunkTest subclass: #MDMemoChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDMemoChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:44'!
testDescription
	| memo chunk actual expected  |
	memo := MDBogusRepositoryResource new setUp repository memos anyOne.
	chunk := MDMemoChunk on: memo.
	actual := self write: chunk.
	expected := '"', memo name, String cr, memo description, '"!!', String cr.
	self assert: actual = expected! !

!MDMemoChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:52'!
testDescriptionWithBang
	| memo chunk actual  |
	memo := (MDBogusRepositoryResource new setUp repository memos anyOne) copy.
	memo properties description: 'This contains a !! inside it'.
	chunk := MDMemoChunk on: memo.
	actual := self write: chunk.
	self assert: (actual includesSubString: '!!!!')! !

!MDMemoChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:52'!
testDescriptionWithDoubleQuote
	| memo chunk actual  |
	memo := (MDBogusRepositoryResource new setUp repository memos anyOne) copy.
	memo properties description: 'This contains a "quoted" phrase'.
	chunk := MDMemoChunk on: memo.
	actual := self write: chunk.
	self assert: (actual includesSubString: '""')! !

MDChunkTest subclass: #MDMethodChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:40'!
initializeExpected
	^ 'BogusA initialize!!

'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:57'!
methodA
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #a
			classIsMeta: true)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:59'!
methodAExpected
	^ '!!BogusA class methodsFor: ''capitals'' stamp: ''cwp 3/28/2008 23:18''!!
a
	^ $A!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:01'!
methodAExpected2
	^ '!!BogusA class methodsFor: ''capitals''!!
a
	^ $A!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/31/2008 00:02'!
methodAExpected3
	^ 'BogusA class removeSelector: #a!!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/18/2008 23:51'!
methodInitialize
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #initialize
			classIsMeta: true)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:36'!
methodInstanceInitialize
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #initialize
			classIsMeta: false)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/28/2008 23:37'!
methodOne
	^ MDMethodChunk forElement: 
		(MDMethodElement 
			className: #BogusA 
			selector: #one)! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:22'!
methodOneExpected
	^ '!!BogusA methodsFor: ''numbers'' stamp: ''cwp 3/28/2008 23:18''!!
one
	^ self!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:22'!
methodOneExpected2
	^ '!!BogusA methodsFor: ''numbers''!!
one
	^ self!! !!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/29/2008 00:59'!
methodOneExpected3
	^ 'BogusA removeSelector: #one!!
'! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testAInitializer
	| chunk properties stream |
	chunk := self methodA.
	properties := MDPropertyDictionary new
		category: #capitals;
		initials: 'cwp';
		timeStamp: (MDTimestamp fromInteger: 886029518);
		source: 'initialize';
		yourself.
	chunk load: properties.
	stream := WriteStream on: String new.
	chunk writeInitializerOn: stream.
	self assert: stream contents isEmpty! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:25'!
testClassDefinitionWithStamp
	| chunk properties actual expected |
	chunk := self methodA.
	properties := MDPropertyDictionary new
					category: #capitals;
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					source: ('a', String cr, '	^ $A');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	expected := self methodAExpected.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testClassDefinitionWithoutStamp
	| chunk properties actual expected |
	chunk := self methodA.
	properties := MDPropertyDictionary new
					category: #capitals;
					source: ('a', String cr, '	^ $A');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	expected := self methodAExpected2.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/26/2008 20:41'!
testClassIsRemoved
	| chunk actual class |
	class := MDClassChunk forElement: (MDClassElement className: #BogusA).
	class remove.
	chunk := self methodA.
	chunk remove.
	chunk reactToClass: class.
	actual := self write: chunk.
	self assert: actual isEmpty! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testClassRemoval
	| chunk actual expected |
	chunk := self methodA.
	chunk remove.
	actual := self write: chunk.
	expected := self methodAExpected3.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testDefinitionWithBang
	| chunk properties actual |
	chunk := self methodOne.
	properties := MDPropertyDictionary new
					category: #numbers;
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					source: ('one', String cr, '	^ ''Sha!!bang''');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	self assert: (actual includesSubString: '!!!!')! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testDefinitionWithStamp
	| chunk properties actual expected |
	chunk := self methodOne.
	properties := MDPropertyDictionary new
					category: #numbers;
					initials: 'cwp';
					timeStamp: (MDTimestamp fromInteger: 886029518);
					source: ('one', String cr, '	^ self');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	expected := self methodOneExpected.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefinitionWithoutStamp
	| chunk properties actual expected |
	chunk := self methodOne.
	properties := MDPropertyDictionary new
					category: #numbers;
					source: ('one', String cr, '	^ self');
					yourself.
	chunk load: properties.
	actual := self write: chunk.
	expected := self methodOneExpected2.
	self assert: actual = expected.! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testInitializer
	| chunk properties actual expected stream |
	chunk := self methodInitialize.
	properties := MDPropertyDictionary new
		category: #capitals;
		initials: 'cwp';
		timeStamp: (MDTimestamp fromInteger: 886029518);
		source: 'initialize';
		yourself.
	chunk load: properties.
	stream := WriteStream on: String new.
	chunk writeInitializerOn: stream.
	actual := stream contents.
	expected := self initializeExpected.
	self assert: actual = expected! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2008 20:26'!
testInstanceInitializer
	| chunk properties stream |
	chunk := self methodInstanceInitialize.
	properties := MDPropertyDictionary new
		category: #capitals;
		initials: 'cwp';
		timeStamp: (MDTimestamp fromInteger: 886029518);
		source: 'initialize';
		yourself.
	chunk load: properties.
	stream := WriteStream on: String new.
	chunk writeInitializerOn: stream.
	self assert: stream contents isEmpty! !

!MDMethodChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/26/2008 20:03'!
testRemoval
	| chunk actual expected |
	chunk := self methodOne.
	chunk remove.
	actual := self write: chunk.
	expected := self methodOneExpected3.
	self assert: actual = expected.! !

MDChunkTest subclass: #MDVariableChunkTest
	instanceVariableNames: 'chunk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

MDVariableChunkTest subclass: #MDClassInstVarChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:30'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB class instVarNames includes: ''first'') ifFalse:
		[BogusB class addInstVarName: ''first'']]!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:36'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB class instVarNames includes: ''first'') ifTrue:
		[BogusB class removeInstVarName: ''first'']]!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:28'!
expectedSimpleDefinition
	^ '(BogusB class instVarNames includes: ''first'') ifFalse:
	[BogusB class addInstVarName: ''first'']!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:36'!
expectedSimpleRemoval
	^ '(BogusB class instVarNames includes: ''first'') ifTrue:
	[BogusB class removeInstVarName: ''first'']!!
'! !

!MDClassInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:13'!
setUp
	chunk := MDClassInstVarChunk forElement: 
				(MDClassInstVarElement className: #BogusB name: #first)! !

MDVariableChunkTest subclass: #MDClassVarChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 22:23'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB classVarNames includes: ''First'') ifFalse:
		[BogusB addClassVarName: ''First'']]!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:23'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB classVarNames includes: ''First'') ifTrue:
		[BogusB removeClassVarName: ''First'']]!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 22:55'!
expectedSimpleDefinition
	^ '(BogusB classVarNames includes: ''First'') ifFalse:
	[BogusB addClassVarName: ''First'']!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:22'!
expectedSimpleRemoval
	^ '(BogusB classVarNames includes: ''First'') ifTrue:
	[BogusB removeClassVarName: ''First'']!!
'! !

!MDClassVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:13'!
setUp
	chunk := MDClassVarChunk forElement: 
				(MDClassVarElement className: #BogusB name: #First)! !

MDVariableChunkTest subclass: #MDInstVarChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:40'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB instVarNames includes: ''first'') ifFalse:
		[BogusB addInstVarName: ''first'']]!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:38'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB instVarNames includes: ''first'') ifTrue:
		[BogusB removeInstVarName: ''first'']]!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:41'!
expectedSimpleDefinition
	^ '(BogusB instVarNames includes: ''first'') ifFalse:
	[BogusB addInstVarName: ''first'']!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 20:31'!
expectedSimpleRemoval
	^ '(BogusB instVarNames includes: ''first'') ifTrue:
	[BogusB removeInstVarName: ''first'']!!
'! !

!MDInstVarChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:15'!
setUp
	chunk := MDInstVarChunk forElement: (MDInstVarElement 
			className: #BogusB
			name: #first)! !

MDVariableChunkTest subclass: #MDPoolImportChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2008 23:45'!
expectedIndependentDefinition
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB sharedPools includes: BogusPool) ifFalse:
		[BogusB addSharedPool: BogusPool]]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:29'!
expectedIndependentRemoval
	^ '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB sharedPools includes: BogusPool) ifTrue:
		[BogusB removeSharedPool: BogusPool]]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:27'!
expectedSimpleDefinition
	^ '(BogusB sharedPools includes: BogusPool) ifFalse:
	[BogusB addSharedPool: BogusPool]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:29'!
expectedSimpleRemoval
	^ '(BogusB sharedPools includes: BogusPool) ifTrue:
	[BogusB removeSharedPool: BogusPool]!!
'! !

!MDPoolImportChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:18'!
setUp
	chunk := MDPoolImportChunk forElement: (MDPoolImportElement 
			className: #BogusB
			name: #BogusPool)! !

!MDVariableChunkTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:30'!
isAbstract
	^ self name = #MDVariableChunkTest! !

!MDVariableChunkTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:30'!
shouldInheritSelectors
	^ true! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/27/2008 00:38'!
testClassIsRemoved
	| actual class |
	class := MDClassChunk forElement: (MDClassElement className: #BogusB).
	class remove.
	chunk reactToClass: class.
	chunk load: MDPropertyDictionary new.
	actual := self write: chunk.
	self assert: actual isEmpty! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:20'!
testIndependentDefinition
	| actual expected |
	chunk load: MDPropertyDictionary new.
	actual := self write: chunk.
	expected := self expectedIndependentDefinition.
	self assert: actual = expected! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:20'!
testIndependentRemoval
	| actual expected |
	chunk remove.
	actual := self write: chunk.
	expected := self expectedIndependentRemoval.
	self assert: actual = expected! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:20'!
testSimpleDefinition
	| actual expected |
	chunk load: MDPropertyDictionary new.
	chunk beDependent.
	actual := self write: chunk.
	expected := self expectedSimpleDefinition.
	self assert: actual = expected! !

!MDVariableChunkTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 21:21'!
testSimpleRemoval
	| actual expected |
	chunk remove.
	chunk beDependent.
	actual := self write: chunk.
	expected := self expectedSimpleRemoval.
	self assert: actual = expected! !

TestCase subclass: #MDFileOutExporterTest
	instanceVariableNames: 'stream exporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDFileOutExporterTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:19'!
resources
	^ {MDBogusRepositoryResource}! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:26'!
bogusAInitialize
	| element variant |
	element := MDMethodElement className: #BogusA selector: #initialize classIsMeta: true.
	variant := MDDefinitionVariant forElement: element.
	variant properties
		category: #capitals;
		initials: 'cwp';
		timestamp: (MDTimestamp fromInteger: 886029518);
		source: 'initialize';
		yourself.
	^ MDElementVersion variant: variant! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/19/2008 00:57'!
classRemoval
	| element variant |
	element := MDClassElement className: #BogusB.
	variant := MDRemovalVariant forElement: element.
	^ MDElementVersion variant: variant! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 13:14'!
get: anElement
	^ self repository versions detect: [:ea | ea element = anElement]! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/24/2008 23:18'!
repository
	^ MDBogusRepositoryResource current repository! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/30/2008 23:20'!
setUp
	stream := WriteStream on: String new.
	exporter := MDFileOutExporter on: stream.! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:22'!
testClassA
	| version actual |
	version := self get: (MDClassElement className: #BogusA).
	actual := self write: version.
	self assert: (actual includesSubstring: 'BogusA' caseSensitive: true)! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:28'!
testClassAClassMethod
	| version actual |
	version := self get: (MDMethodElement
						className: #BogusA
						selector: #isCompletelyUseless
						classIsMeta: true).
	actual := self write: version.
	self assert: actual = '!!BogusA class methodsFor: ''testing'' stamp: ''cwp 4/1/2006 23:02''!!
isCompletelyUseless
	^ true!! !!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:29'!
testClassAComment
	| version actual |
	version := self get: (MDClassCommentElement className: #BogusA).
	actual := self write: version.
	self assert: actual = '!!BogusA commentStamp: ''cwp 5/30/2004 09:27'' prior: 0!!
Comment for BogusA!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:31'!
testClassBClassInstVar
	| version actual |
	version := self get: (MDClassInstVarElement 
							className: #BogusB 
							name: #firstClassInstanceVariableB).
	actual := self write: version.
	self assert: actual = '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB class instVarNames includes: ''firstClassInstanceVariableB'') ifFalse:
		[BogusB class addInstVarName: ''firstClassInstanceVariableB'']]!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:32'!
testClassBClassVar
	| version actual |
	version := self get: (MDClassVarElement className: #BogusB name: #FirstClassVariableB).
	actual := self write: version.
	self assert: actual = '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB classVarNames includes: ''FirstClassVariableB'') ifFalse:
		[BogusB addClassVarName: ''FirstClassVariableB'']]!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:33'!
testClassBInstVar
	| version actual |
	version := self get: (MDInstVarElement className: #BogusB name: #firstInstanceVariableB).
	actual := self write: version.
	self assert: actual = '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB instVarNames includes: ''firstInstanceVariableB'') ifFalse:
		[BogusB addInstVarName: ''firstInstanceVariableB'']]!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:34'!
testClassBMethod
	| version actual |
	version := self get: (MDMethodElement className: #BogusB selector: #foo).
	actual := self write: version.
	self assert: actual = '!!BogusB methodsFor: ''accessing''!!
foo
	^ self!! !!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:35'!
testClassBPoolImport
	| version actual |
	version := self get: (MDPoolImportElement className: #BogusB name: #BogusPool).
	actual := self write: version.
	self assert: actual = '(Smalltalk hasClassNamed: #BogusB) ifTrue:
	[(BogusB sharedPools includes: BogusPool) ifFalse:
		[BogusB addSharedPool: BogusPool]]!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:37'!
testClassRemoval
	| actual |
	exporter addVersion: (self get: (MDClassElement className: #BogusA)).
	exporter addVersion: self classRemoval.
	exporter harmonize; flush.
	actual := stream contents.
	self assert: actual = 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base''!!

Smalltalk removeClassNamed: #BogusB!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 22:02'!
testCompleteSnapshot
	| memo |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	self assert: stream contents size > 3000.! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2008 22:05'!
testDependenciesHonored
	| memo fileout |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	fileout := stream contents.
	self deny: (fileout includesSubString: 'Smalltalk hasClassNamed:')! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:46'!
testExtensionMethod
	| actual version1 version2 index1 index2 |
	version1 := self get: (MDMethodElement className: #BogusB selector: #foo).
	version2 := self get: (MDClassElement className: #BogusA).
	exporter addVersion: version1.
	exporter addVersion: version2.
	exporter harmonize.
	exporter flush.
	actual := stream contents.
	index1 := actual indexOfSubCollection: 'BogusA'.
	index2 := actual indexOfSubCollection: 'BogusB'.
	self assert: index1 < index2! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 00:47'!
testInitializerMethod
	| version actual |
	version := self bogusAInitialize.
	actual := self write: version.
	self assert: actual = '!!BogusA class methodsFor: ''capitals''!!
initialize!! !!

BogusA initialize!!

'! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/13/2008 16:34'!
testSharedPoolsFirst
	| memo fileout index1 index2 |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	fileout := stream contents.
	index1 := fileout indexOfSubCollection: 'BogusPool'.
	index2 := fileout indexOfSubCollection: 'BogusA'.
	self assert: index1 < index2! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:02'!
testSuperclassOrder
	| memo fileout index1 index2 |
	memo := self repository memos anyOne.
	exporter export: memo from: self repository.
	fileout := stream contents.
	index1 := fileout indexOfSubCollection: 'BogusA'.
	index2 := fileout indexOfSubCollection: 'BogusE'.
	self assert: index1 < index2! !

!MDFileOutExporterTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2008 21:24'!
write: aVersion
	exporter addVersion: aVersion.
	exporter flush.
	^ stream contents! !

TestCase subclass: #MDKeyedStreamTest
	instanceVariableNames: 'dataStream baseStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:24'!
append: aSmallInteger
	dataStream 
		appendKey: (self key: aSmallInteger)
		value: (self value: aSmallInteger).
! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:19'!
assert: bytes is: aSmallInteger
	self assert: bytes last = aSmallInteger! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 5/22/2008 00:11'!
bytes: count containing: aSmallInteger
	| key |
	key := ByteArray new: count.
	key at: key size put: aSmallInteger.
	^ key! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:02'!
key: aSmallInteger
	^ self bytes: dataStream keySize containing: aSmallInteger! !

!MDKeyedStreamTest methodsFor: 'running' stamp: 'avi 4/17/2005 01:19'!
setUp
	baseStream := RWBinaryOrTextStream on: (ByteArray new: 100).
	dataStream := MDKeyedStream on: baseStream! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 4/10/2005 16:11'!
testAppend
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p |
		self assert: k is: 1.
		self assert: v is: 1.
		self assert: p >= 0]! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testKeysValuePositions
	| index position |
	1 to: 3 do: [:i | self append: i].
	index := 1.
	position := -1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p |
		self assert: k is: index.
		self assert: v is: index.
		self assert: p > position.
		position := p.
		index := index + 1]! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testPosition
	| position |
	position := dataStream nextValuePosition.
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p | self assert: p = position].
! !

!MDKeyedStreamTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testValueAtPosition
	| position |
	self append: 1.
	dataStream keysValuesAndPositionsDo: 
		[:k :v :p | position := p].
	self assert: (dataStream valueAtPosition: position) is: 1! !

!MDKeyedStreamTest methodsFor: 'support' stamp: 'cwp 4/10/2005 16:07'!
value: aSmallInteger
	^ self bytes: dataStream keySize * 2 containing: aSmallInteger! !

TestCase subclass: #MDNetLocatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetLocatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDefaultPort
	| locator |
	locator := MDNetLocator host: 'source.wiresong.ca'.
	self assert: locator port = 6101! !

!MDNetLocatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDescription
	| locator |
	locator := MDNetLocator host: 'source.wiresong.ca' port: 6101.
	self assert: locator description = 'source.wiresong.ca:6101'! !

!MDNetLocatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDescriptionWithoutPort
	| locator |
	locator := MDNetLocator host: 'source.wiresong.ca'.
	self assert: locator description = 'source.wiresong.ca'! !

!MDNetLocatorTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testHost
	| locator |
	locator := MDNetLocator host: 'source.wiresong.ca'.
	self assert: locator host = 'source.wiresong.ca'! !

TestResource subclass: #MDBogusRepositoryResource
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDBogusRepositoryResource class methodsFor: 'as yet unclassified' stamp: 'cwp 4/18/2008 08:06'!
compileContents: aSet
	 | source |
	source := String streamContents:
		[:stream |
		stream 
			nextPutAll: 'contents';
			crtab;
			nextPutAll: '^ MDMarshal materialize: #('.
		(MDMarshal serialize: aSet)
			do: [:b | stream print: b] separatedBy: [stream space].
		stream nextPut: $)].
	
	self compile: source ! !

!MDBogusRepositoryResource class methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 13:13'!
recompile
	| versions snapshot properties memo objects |
	versions := self new setUp repository versions asSet.
	snapshot := MDSnapshot withVersions: versions.
	properties := MDPropertyDictionary new
		author: 'Colin Putney <cputney@wiresong.ca>';
		comment: 'Snapshot for testing.';
		initials: 'cwp';	
		ordinal: 1;
		sliceName: 'Bogus';
		yourself.
	memo := MDMemo snapshot: snapshot slice: (MDPackageInfoSlice named: 'Bogus') parents: #() properties: properties.
	objects := versions, {snapshot. memo}.
	self compileContents: (objects asArray sort: [:a :b | a hashstamp <= b hashstamp])! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 8/9/2009 01:05'!
contents
	^ MDMarshal materialize: #(17 9 40 23 5 9 5 22 52 210 77 14 52 231 205 170 249 9 150 132 226 101 8 89 190 3 184 54 173 221 73 95 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 65 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 10 66 111 103 117 115 45 66 97 115 101 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 22 52 210 77 15 61 45 189 178 223 168 83 176 193 250 37 95 154 78 44 42 38 199 60 221 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 66 14 9 22 115 101 110 100 115 83 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 115 101 110 100 101 114 115 14 9 6 115 111 117 114 99 101 15 9 46 115 101 110 100 115 83 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 13 9 115 101 108 102 32 115 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 18 9 0 23 5 9 5 22 52 210 77 15 178 81 54 218 189 119 201 106 75 113 238 141 169 50 185 129 13 149 226 25 1 5 9 2 1 5 9 11 14 9 6 66 111 103 117 115 66 15 9 23 115 101 99 111 110 100 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 22 52 210 77 15 103 181 246 76 222 120 245 4 240 231 10 78 122 7 176 194 141 103 99 210 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 3 111 110 101 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 110 117 109 98 101 114 115 14 9 6 115 111 117 114 99 101 15 9 8 111 110 101 13 9 94 32 49 18 9 0 23 5 9 5 22 52 210 77 15 37 101 63 31 21 93 91 181 27 36 1 22 247 129 50 251 113 246 113 109 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 67 14 9 12 104 97 115 84 105 109 101 115 116 97 109 112 8 20 9 4 14 9 8 99 97 116 101 103 111 114 121 14 9 7 116 101 115 116 105 110 103 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 6 115 111 117 114 99 101 15 9 20 104 97 115 84 105 109 101 115 116 97 109 112 13 9 94 32 116 114 117 101 14 9 9 116 105 109 101 83 116 97 109 112 21 45 159 254 52 18 9 0 23 5 9 5 22 52 210 77 15 97 131 57 131 223 77 24 55 160 77 37 167 231 158 13 192 136 242 235 119 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 66 14 9 12 97 99 99 101 115 115 101 115 73 118 97 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 9 97 99 99 101 115 115 105 110 103 14 9 6 115 111 117 114 99 101 15 9 38 97 99 99 101 115 115 101 115 73 118 97 114 13 9 94 32 102 105 114 115 116 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 18 9 0 23 5 9 5 22 52 210 77 15 0 96 22 96 186 91 34 6 210 251 173 9 35 1 19 142 16 235 91 185 1 5 9 2 1 5 9 11 14 9 6 66 111 103 117 115 66 15 9 22 102 105 114 115 116 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 22 52 210 77 15 127 102 112 135 183 139 81 238 28 8 124 5 41 100 83 15 121 166 79 159 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 1 97 7 20 9 4 14 9 8 99 97 116 101 103 111 114 121 14 9 8 99 97 112 105 116 97 108 115 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 6 115 111 117 114 99 101 15 9 7 97 13 9 94 32 36 66 14 9 9 116 105 109 101 83 116 97 109 112 21 49 17 69 60 18 9 0 23 5 9 5 22 52 210 77 15 244 222 112 92 102 167 130 99 8 181 45 21 239 216 90 161 235 54 32 150 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 69 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 10 66 111 103 117 115 45 66 97 115 101 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 66 111 103 117 115 65 18 9 0 23 5 9 5 22 52 210 77 15 114 39 31 132 67 227 32 151 94 159 185 49 10 186 151 214 128 18 156 190 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 67 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 10 66 111 103 117 115 45 66 97 115 101 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 22 52 210 77 15 235 132 41 59 29 172 151 93 65 63 89 87 11 139 131 93 203 27 70 190 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 66 14 9 16 97 99 99 101 115 115 101 115 67 86 97 114 65 108 115 111 7 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 9 97 99 99 101 115 115 105 110 103 14 9 6 115 111 117 114 99 101 15 9 39 97 99 99 101 115 115 101 115 67 86 97 114 65 108 115 111 13 9 94 32 70 105 114 115 116 67 108 97 115 115 86 97 114 105 97 98 108 101 66 18 9 0 23 5 9 5 22 52 210 77 15 192 75 13 44 171 2 83 203 214 251 38 81 214 25 25 178 151 220 117 31 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 1 98 7 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 8 99 97 112 105 116 97 108 115 14 9 6 115 111 117 114 99 101 15 9 7 98 13 9 94 32 36 66 18 9 0 23 5 9 5 22 52 210 77 15 124 211 224 13 102 27 175 154 33 126 153 141 123 134 252 171 129 212 111 47 1 5 9 2 1 5 9 13 14 9 6 66 111 103 117 115 66 15 9 28 115 101 99 111 110 100 67 108 97 115 115 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 22 52 210 77 15 12 161 138 118 66 53 74 7 205 44 17 60 168 209 207 137 42 8 101 114 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 74 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 4 119 101 97 107 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 22 52 210 77 15 84 197 83 60 201 6 30 247 56 50 3 223 18 54 188 15 235 162 82 21 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 19 105 115 67 111 109 112 108 101 116 101 108 121 85 115 101 108 101 115 115 7 20 9 4 14 9 8 99 97 116 101 103 111 114 121 14 9 7 116 101 115 116 105 110 103 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 6 115 111 117 114 99 101 15 9 27 105 115 67 111 109 112 108 101 116 101 108 121 85 115 101 108 101 115 115 13 9 94 32 116 114 117 101 14 9 9 116 105 109 101 83 116 97 109 112 21 49 17 70 104 18 9 0 23 5 9 5 22 52 210 77 15 174 199 45 103 130 222 113 206 114 7 199 136 85 139 27 160 138 60 53 104 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 28 98 111 103 117 115 72 111 112 101 102 117 108 108 121 85 110 105 113 117 101 83 101 108 101 99 116 111 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 5 111 116 104 101 114 14 9 6 115 111 117 114 99 101 15 9 59 98 111 103 117 115 72 111 112 101 102 117 108 108 121 85 110 105 113 117 101 83 101 108 101 99 116 111 114 13 9 115 101 108 102 32 98 111 103 117 115 79 116 104 101 114 85 110 105 113 117 101 83 101 108 101 99 116 111 114 18 9 0 23 5 9 5 22 52 210 77 15 85 7 149 75 76 191 83 164 68 197 12 238 62 108 118 102 53 51 25 146 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 4 102 105 118 101 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 110 117 109 98 101 114 115 14 9 6 115 111 117 114 99 101 15 9 29 102 105 118 101 13 9 94 32 115 101 108 102 32 116 119 111 32 43 32 115 101 108 102 32 116 104 114 101 101 18 9 0 23 5 9 5 22 52 210 77 15 234 101 88 215 90 39 34 19 190 35 248 135 77 47 119 172 132 129 130 45 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 71 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 5 98 121 116 101 115 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 22 52 210 77 15 180 202 40 165 94 45 91 44 94 95 13 150 101 0 68 221 87 17 206 66 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 66 14 9 3 102 111 111 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 9 97 99 99 101 115 115 105 110 103 14 9 6 115 111 117 114 99 101 15 9 11 102 111 111 13 9 94 32 115 101 108 102 18 9 0 23 5 9 5 22 52 210 77 15 194 200 69 48 219 8 193 197 224 64 242 33 226 124 130 171 157 235 240 156 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 8 105 115 83 116 114 105 110 103 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 5 111 116 104 101 114 14 9 6 115 111 117 114 99 101 15 9 17 105 115 83 116 114 105 110 103 13 9 94 32 102 97 108 115 101 18 9 0 23 5 9 5 22 52 210 77 15 100 251 36 27 189 182 116 22 214 53 106 67 117 15 54 73 188 59 162 171 1 5 9 2 1 5 9 12 14 9 6 66 111 103 117 115 66 14 9 19 70 105 114 115 116 67 108 97 115 115 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 22 52 210 77 15 202 123 201 142 179 22 126 136 162 188 187 169 250 199 124 21 159 214 180 84 1 5 9 2 1 5 9 14 14 9 6 66 111 103 117 115 66 14 9 9 66 111 103 117 115 80 111 111 108 20 9 0 18 9 0 23 5 9 5 22 52 210 77 15 83 103 37 53 8 92 100 220 243 206 109 93 253 239 107 49 164 1 65 36 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 70 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 22 52 210 77 15 73 242 198 17 93 106 121 199 75 191 141 96 100 79 142 158 152 155 94 175 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 5 116 104 114 101 101 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 110 117 109 98 101 114 115 14 9 6 115 111 117 114 99 101 15 9 10 116 104 114 101 101 13 9 94 32 51 18 9 0 23 5 9 5 22 52 210 77 15 190 38 67 92 97 67 244 24 254 111 238 52 234 82 134 218 87 232 239 221 1 5 9 2 1 5 9 12 14 9 6 66 111 103 117 115 66 14 9 20 83 101 99 111 110 100 67 108 97 115 115 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 5 22 52 210 77 15 130 165 202 235 187 78 91 26 22 229 26 79 10 18 191 173 137 238 65 178 1 5 9 2 1 5 9 10 14 9 6 66 111 103 117 115 65 20 9 3 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 4 116 101 120 116 15 9 18 67 111 109 109 101 110 116 32 102 111 114 32 66 111 103 117 115 65 14 9 9 116 105 109 101 83 116 97 109 112 21 45 155 232 228 18 9 0 23 5 9 5 22 52 210 77 15 237 166 92 141 201 208 41 114 181 163 176 96 229 8 73 205 123 107 80 195 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 3 116 119 111 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 110 117 109 98 101 114 115 14 9 6 115 111 117 114 99 101 15 9 8 116 119 111 13 9 94 32 50 18 9 0 23 5 9 5 22 52 210 77 15 185 121 79 71 245 202 96 155 100 117 149 152 63 54 121 166 210 126 240 4 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 1 98 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 108 101 116 116 101 114 115 14 9 6 115 111 117 114 99 101 15 9 7 98 13 9 94 32 36 66 18 9 0 23 5 9 5 22 52 210 77 15 182 111 208 115 69 214 134 126 221 103 177 88 113 230 157 219 240 28 145 70 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 24 98 111 103 117 115 79 116 104 101 114 85 110 105 113 117 101 83 101 108 101 99 116 111 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 5 111 116 104 101 114 14 9 6 115 111 117 114 99 101 15 9 32 98 111 103 117 115 79 116 104 101 114 85 110 105 113 117 101 83 101 108 101 99 116 111 114 13 9 94 32 115 101 108 102 18 9 0 23 5 9 5 22 52 210 77 15 13 153 252 85 5 231 220 195 191 39 76 181 177 216 17 97 222 141 233 177 1 5 9 2 1 5 9 9 14 9 9 66 111 103 117 115 80 111 111 108 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 11 66 111 103 117 115 45 80 111 111 108 115 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 10 83 104 97 114 101 100 80 111 111 108 18 9 0 23 5 9 5 22 52 210 77 15 56 135 171 204 143 51 44 23 172 188 180 175 38 16 193 109 238 7 147 158 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 66 14 9 12 97 99 99 101 115 115 101 115 67 86 97 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 9 97 99 99 101 115 115 105 110 103 14 9 6 115 111 117 114 99 101 15 9 35 97 99 99 101 115 115 101 115 67 86 97 114 13 9 94 32 70 105 114 115 116 67 108 97 115 115 86 97 114 105 97 98 108 101 66 18 9 0 23 5 9 5 22 52 210 77 15 14 60 23 94 19 238 118 253 208 68 157 14 25 195 215 183 252 177 80 162 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 1 97 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 108 101 116 116 101 114 115 14 9 6 115 111 117 114 99 101 15 9 7 97 13 9 94 32 36 65 18 9 0 23 5 9 5 22 52 210 77 15 120 220 20 10 115 48 47 190 159 207 79 4 177 43 72 157 68 225 184 32 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 72 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 8 118 97 114 105 97 98 108 101 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 22 52 210 77 15 214 21 181 95 91 185 196 101 226 208 37 56 214 23 240 64 247 129 10 79 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 66 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 10 66 111 103 117 115 45 66 97 115 101 14 9 6 102 111 114 109 97 116 14 9 6 110 111 114 109 97 108 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 22 52 210 77 15 231 84 147 29 195 242 183 254 48 149 125 134 32 249 170 86 74 117 154 81 1 5 9 2 1 5 9 9 14 9 6 66 111 103 117 115 73 20 9 3 14 9 8 99 97 116 101 103 111 114 121 14 9 13 66 111 103 117 115 45 70 111 114 109 97 116 115 14 9 6 102 111 114 109 97 116 14 9 5 119 111 114 100 115 14 9 14 115 117 112 101 114 99 108 97 115 115 78 97 109 101 14 9 6 79 98 106 101 99 116 18 9 0 23 5 9 5 22 52 210 77 15 172 113 166 5 104 236 190 161 157 134 239 109 236 157 22 168 31 73 194 145 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 65 14 9 19 98 111 103 117 115 85 110 115 101 110 116 83 101 108 101 99 116 111 114 8 20 9 4 14 9 8 99 97 116 101 103 111 114 121 14 9 5 111 116 104 101 114 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 6 115 111 117 114 99 101 15 9 27 98 111 103 117 115 85 110 115 101 110 116 83 101 108 101 99 116 111 114 13 9 94 32 115 101 108 102 14 9 9 116 105 109 101 83 116 97 109 112 21 50 96 25 84 18 9 0 23 5 9 5 22 52 210 77 15 62 175 205 208 183 226 168 140 69 151 12 91 60 28 92 18 175 234 226 58 1 5 9 2 1 5 9 15 14 9 6 66 111 103 117 115 66 14 9 17 115 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 8 20 9 2 14 9 8 99 97 116 101 103 111 114 121 14 9 7 115 101 110 100 101 114 115 14 9 6 115 111 117 114 99 101 15 9 36 115 101 110 100 115 65 99 99 101 115 115 101 115 73 118 97 114 13 9 115 101 108 102 32 97 99 99 101 115 115 101 115 73 118 97 114 18 9 0 23 5 9 5 22 52 210 77 15 109 25 42 228 7 248 182 246 80 80 214 183 197 80 31 252 163 148 21 41 1 5 9 2 1 5 9 13 14 9 6 66 111 103 117 115 66 15 9 27 102 105 114 115 116 67 108 97 115 115 73 110 115 116 97 110 99 101 86 97 114 105 97 98 108 101 66 20 9 0 18 9 0 23 5 9 6 22 53 3 166 54 229 37 37 226 2 209 243 112 199 17 131 84 93 67 14 95 228 70 233 84 18 9 38 22 52 210 77 15 180 202 40 165 94 45 91 44 94 95 13 150 101 0 68 221 87 17 206 66 22 52 210 77 15 109 25 42 228 7 248 182 246 80 80 214 183 197 80 31 252 163 148 21 41 22 52 210 77 15 194 200 69 48 219 8 193 197 224 64 242 33 226 124 130 171 157 235 240 156 22 52 210 77 15 172 113 166 5 104 236 190 161 157 134 239 109 236 157 22 168 31 73 194 145 22 52 210 77 14 52 231 205 170 249 9 150 132 226 101 8 89 190 3 184 54 173 221 73 95 22 52 210 77 15 37 101 63 31 21 93 91 181 27 36 1 22 247 129 50 251 113 246 113 109 22 52 210 77 15 235 132 41 59 29 172 151 93 65 63 89 87 11 139 131 93 203 27 70 190 22 52 210 77 15 231 84 147 29 195 242 183 254 48 149 125 134 32 249 170 86 74 117 154 81 22 52 210 77 15 182 111 208 115 69 214 134 126 221 103 177 88 113 230 157 219 240 28 145 70 22 52 210 77 15 234 101 88 215 90 39 34 19 190 35 248 135 77 47 119 172 132 129 130 45 22 52 210 77 15 103 181 246 76 222 120 245 4 240 231 10 78 122 7 176 194 141 103 99 210 22 52 210 77 15 14 60 23 94 19 238 118 253 208 68 157 14 25 195 215 183 252 177 80 162 22 52 210 77 15 61 45 189 178 223 168 83 176 193 250 37 95 154 78 44 42 38 199 60 221 22 52 210 77 15 124 211 224 13 102 27 175 154 33 126 153 141 123 134 252 171 129 212 111 47 22 52 210 77 15 202 123 201 142 179 22 126 136 162 188 187 169 250 199 124 21 159 214 180 84 22 52 210 77 15 190 38 67 92 97 67 244 24 254 111 238 52 234 82 134 218 87 232 239 221 22 52 210 77 15 97 131 57 131 223 77 24 55 160 77 37 167 231 158 13 192 136 242 235 119 22 52 210 77 15 127 102 112 135 183 139 81 238 28 8 124 5 41 100 83 15 121 166 79 159 22 52 210 77 15 185 121 79 71 245 202 96 155 100 117 149 152 63 54 121 166 210 126 240 4 22 52 210 77 15 83 103 37 53 8 92 100 220 243 206 109 93 253 239 107 49 164 1 65 36 22 52 210 77 15 100 251 36 27 189 182 116 22 214 53 106 67 117 15 54 73 188 59 162 171 22 52 210 77 15 214 21 181 95 91 185 196 101 226 208 37 56 214 23 240 64 247 129 10 79 22 52 210 77 15 192 75 13 44 171 2 83 203 214 251 38 81 214 25 25 178 151 220 117 31 22 52 210 77 15 56 135 171 204 143 51 44 23 172 188 180 175 38 16 193 109 238 7 147 158 22 52 210 77 15 62 175 205 208 183 226 168 140 69 151 12 91 60 28 92 18 175 234 226 58 22 52 210 77 15 130 165 202 235 187 78 91 26 22 229 26 79 10 18 191 173 137 238 65 178 22 52 210 77 15 237 166 92 141 201 208 41 114 181 163 176 96 229 8 73 205 123 107 80 195 22 52 210 77 15 0 96 22 96 186 91 34 6 210 251 173 9 35 1 19 142 16 235 91 185 22 52 210 77 15 114 39 31 132 67 227 32 151 94 159 185 49 10 186 151 214 128 18 156 190 22 52 210 77 15 85 7 149 75 76 191 83 164 68 197 12 238 62 108 118 102 53 51 25 146 22 52 210 77 15 120 220 20 10 115 48 47 190 159 207 79 4 177 43 72 157 68 225 184 32 22 52 210 77 15 84 197 83 60 201 6 30 247 56 50 3 223 18 54 188 15 235 162 82 21 22 52 210 77 15 12 161 138 118 66 53 74 7 205 44 17 60 168 209 207 137 42 8 101 114 22 52 210 77 15 174 199 45 103 130 222 113 206 114 7 199 136 85 139 27 160 138 60 53 104 22 52 210 77 15 178 81 54 218 189 119 201 106 75 113 238 141 169 50 185 129 13 149 226 25 22 52 210 77 15 244 222 112 92 102 167 130 99 8 181 45 21 239 216 90 161 235 54 32 150 22 52 210 77 15 73 242 198 17 93 106 121 199 75 191 141 96 100 79 142 158 152 155 94 175 22 52 210 77 15 13 153 252 85 5 231 220 195 191 39 76 181 177 216 17 97 222 141 233 177 23 5 9 7 22 53 3 166 54 130 165 231 52 111 158 2 155 193 176 132 194 121 175 137 159 49 93 76 108 22 53 3 166 54 229 37 37 226 2 209 243 112 199 17 131 84 93 67 14 95 228 70 233 84 17 9 0 20 9 5 14 9 6 97 117 116 104 111 114 15 9 34 67 111 108 105 110 32 80 117 116 110 101 121 32 60 99 112 117 116 110 101 121 64 119 105 114 101 115 111 110 103 46 99 97 62 14 9 7 99 111 109 109 101 110 116 15 9 21 83 110 97 112 115 104 111 116 32 102 111 114 32 116 101 115 116 105 110 103 46 14 9 8 105 110 105 116 105 97 108 115 15 9 3 99 119 112 14 9 7 111 114 100 105 110 97 108 9 1 14 9 9 115 108 105 99 101 78 97 109 101 15 9 5 66 111 103 117 115 22 0 0 0 0 78 149 30 110 111 68 98 51 59 230 212 62 130 88 246 4 77 50 78 124)! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 4/7/2008 23:34'!
fileout
	| out exporter memo |
	out := WriteStream on: String new.
	exporter := MDFileOutExporter on: out.
	memo := repository memos anyOne.
	exporter export: memo from: repository.
	^ out contents

! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 3/23/2008 23:48'!
repository
	^ repository! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 4/30/2008 06:54'!
setUp
	
	repository := MDMemoryRepository new.
	repository putAll: self contents! !

!MDBogusRepositoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
tearDown
	repository := nil! !

MDRepository subclass: #MDDirectoryRepository
	instanceVariableNames: 'name directory primary secondary nameOfPrimary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Directory'!

!MDDirectoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2008 21:42'!
named: aString
	^ self new setName: aString! !

!MDDirectoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 8/18/2008 20:00'!
on: aDirectory
	^ self new setDirectory: aDirectory! !

!MDDirectoryRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 10/27/2008 22:36'!
type
	^ #McrDirectory! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/21/2008 20:25'!
addFileNamed: aString
	| stream |
	stream := directory oldFileNamed: aString.
	secondary add: (MDFileRepository on: stream)! !

!MDDirectoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/21/2008 20:13'!
allHashstamps
	| hashstamps |
	self scanDirectory.
	hashstamps := primary allHashstamps asSet.
	secondary do: [:ea | hashstamps addAll: ea allHashstamps].
	^ hashstamps! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'jf 10/25/2008 13:30'!
close
	super close.
	primary isNil ifFalse: [primary close].
	secondary isNil ifFalse: [secondary do: [:each | each close]]! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 11/23/2008 13:13'!
createDirectory
	directory assureExistence.
	self setPrimary: (MDFileRepository on: (directory newFileNamed: self primaryFilename)).! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 13:18'!
description
	^ self name, '/', self primaryName! !

!MDDirectoryRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:21'!
elementClass
	^ MDDirectoryRepositoryElement! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/21/2008 20:10'!
entryIsSecondary: entry 
	^ entry isDirectory not 
		and: [ (entry name endsWith: '.mcr') 
			and: [ entry name ~= primary name ] ]! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/21/2008 20:19'!
fileNames
	^ directory entries 
		inject: Set new
		into: 
			[ :set :entry | 
			(self entryIsSecondary: entry) ifTrue: [set add: entry name].
			set ].
	! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 8/21/2008 20:12'!
get: aHashstamp
	^ (primary get: aHashstamp) ifNil:
		[self scanDirectory.
		secondary do: [:ea | (ea get: aHashstamp) ifNotNilDo: [:obj | ^ obj]].
		nil]! !

!MDDirectoryRepository methodsFor: 'testing' stamp: 'cwp 4/21/2009 14:25'!
hasPrimaryName
	^ nameOfPrimary notNil! !

!MDDirectoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/21/2008 20:13'!
includes: aHashstamp
	^ (primary includes: aHashstamp) or: 
		[self scanDirectory.
		secondary anySatisfy: [:ea | ea includes: aHashstamp]]! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 11/23/2008 13:08'!
initFiles
	secondary := Set new.
	directory exists 
		ifTrue: 
			[self openPrimary. 
			self scanDirectory]
		ifFalse: 
			[self createDirectory]
! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 8/21/2008 20:12'!
memos
	| memos |
	memos := primary memos.
	self scanDirectory.
	secondary do: [:ea | memos addAll: ea memos].
	^ memos! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 13:17'!
name
	^ name! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 11/23/2008 13:14'!
openPrimary
	| filename |
	filename := self primaryFilename.
	self setPrimary: (MDFileRepository on: (directory fileNamed: filename)). ! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 13:13'!
primaryFilename
	^ self primaryName, '.mcr'! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:21'!
primaryName
	^ nameOfPrimary ifNil:
		[MDPlatform current initials]! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:24'!
primaryName: aString
	nameOfPrimary := aString! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 15:57'!
properties: properties
	| changed |
	changed := self updateName: properties name.
	changed := changed | (self updatePrimaryName: properties primaryName).
	changed ifTrue: [self initFiles].! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 8/17/2008 22:41'!
put: anObject
	primary put: anObject! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/20/2008 22:19'!
scanDirectory
	| filenames reponames |
	filenames := self fileNames.
	reponames := secondary collect: [ :ea | ea name ].
	filenames do: [ :ea | (reponames includes: ea) ifFalse: [ self addFileNamed: ea ] ].
	secondary removeAllSuchThat: [ :ea | (filenames includes: ea name) not ]! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 8/21/2008 20:23'!
setDirectory: aDirectory 
	directory := aDirectory.
	name := aDirectory localName.
	self initFiles.
	self initId! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 8/20/2008 20:52'!
setName: aString 
	name := aString.
	directory := FileDirectory default directoryNamed: aString.
	self initFiles.
	self initId! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'jf 10/25/2008 13:28'!
setPrimary: aFileRepository
	primary isNil ifFalse: [primary close].
	primary := aFileRepository! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:17'!
update: properties
	super update: properties.
	properties primaryName: self primaryName.
	^ properties! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 15:40'!
updateName: newName
	| parent |
	name = newName ifTrue: [^ false].
	directory 
		ifNil: [parent := FileDirectory default]
		ifNotNil: 
			[self close.
			parent := directory containingDirectory.
			parent rename: name toBe: newName].
	name := newName.
	directory := parent directoryNamed: name.
	^ true! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:22'!
updatePrimaryName: aString
	nameOfPrimary = aString ifTrue: [^ false].
	nameOfPrimary := aString.
	^ true! !

MDRepository subclass: #MDFileRepository
	instanceVariableNames: 'dataStream index memos lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-File'!

!MDFileRepository class methodsFor: 'accessing' stamp: 'cwp 10/12/2005 21:30'!
extension
	^ '.mcr'! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'cwp 2/2/2006 22:20'!
named: aString
	^ self on: (FileStream fileNamed: aString, self extension)! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'dc 7/19/2007 10:41'!
named: aString do: aBlock
	^ self
		on: (FileStream fileNamed: aString, self extension)
		do: aBlock! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'dc 6/14/2007 06:50'!
on: aFileStream
	^ self new
		initializeWithStream: aFileStream;
		yourself! !

!MDFileRepository class methodsFor: 'instance creation' stamp: 'dc 7/19/2007 10:41'!
on: aFileStream do: aBlock
	|repos|
	repos := self new
				initializeWithStream: aFileStream;
				yourself.
	^ [aBlock value: repos]
		ensure: [repos close]! !

!MDFileRepository class methodsFor: 'class initialization' stamp: 'cwp 10/22/2008 20:47'!
startUp
	"Do nothing. This is implemented because old versions registered
	to be notified at start up, and that registration might still be in effect."! !

!MDFileRepository class methodsFor: 'accessing' stamp: 'cwp 5/31/2008 14:49'!
type
	^ #McrFile! !

!MDFileRepository methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:22'!
= other
	^ self species = other species
		and: [other dataStreamIs: dataStream]! !

!MDFileRepository methodsFor: 'synchronization' stamp: 'cwp 12/23/2007 00:11'!
allHashstamps
	self rescanData.
	^ index keys collect: [:ea | MDHashstamp fromBytes: ea]! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 10/13/2005 23:01'!
close
	dataStream close! !

!MDFileRepository methodsFor: 'private' stamp: 'cwp 12/25/2006 15:23'!
dataStreamIs: aStream
	^ dataStream = aStream! !

!MDFileRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:22'!
elementClass
	^ MDFileRepositoryElement! !

!MDFileRepository methodsFor: 'private' stamp: 'cwp 10/22/2008 20:44'!
flushIndex	
	lastPosition := 0.
	index := Dictionary new.
	memos := Set new.
	! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 10/22/2008 20:45'!
get: aHashstamp 
	| key bytes position |
	key := aHashstamp bytes.
	position := index at: key ifAbsent: [^self rescanData ifTrue: [self get: aHashstamp]].
	bytes := dataStream valueAtPosition: position.
	bytes ifNil:
		[self flushIndex.
		self rescanData.
		bytes := dataStream valueAtPosition: position].
	^ bytes ifNotNil: [MDMarshal materialize: bytes]! !

!MDFileRepository methodsFor: 'comparing' stamp: 'cwp 12/25/2006 15:25'!
hash
	^ dataStream hash! !

!MDFileRepository methodsFor: 'synchronization' stamp: 'cwp 12/23/2007 00:12'!
includes: aHashstamp
	self rescanData.
	^ index includesKey: aHashstamp bytes! !

!MDFileRepository methodsFor: 'initialize-release' stamp: 'cwp 7/27/2008 14:46'!
initializeWithStream: aFileStream 
	self setStream: aFileStream.
	self initId! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 1/19/2007 20:57'!
memos
	
	self rescanData.
	^ memos! !

!MDFileRepository methodsFor: 'public' stamp: 'cwp 5/31/2008 14:43'!
name
	^ dataStream stream localName! !

!MDFileRepository methodsFor: 'accessing' stamp: 'jf 10/25/2008 13:45'!
properties: properties 
	| oldName newName |
	newName := properties name.
	dataStream
		ifNil: [self initializeWithStream: (FileDirectory default fileNamed: newName)]
		ifNotNil:
			[oldName := dataStream stream localName.
			oldName = properties name ifFalse: 
				[ | directory |
				directory := dataStream stream directory.
				self close.
				directory rename: oldName toBe: newName.
				self initializeWithStream: (directory oldFileNamed: newName)]]! !

!MDFileRepository methodsFor: 'public' stamp: 'dc 6/14/2007 07:18'!
put: aHashedObject
	| key value |
	key := aHashedObject hashstamp bytes.
	index at: key ifAbsent:
		[value := MDMarshal serialize: aHashedObject.
		index at: key put: dataStream nextValuePosition.
		dataStream appendKey: key value: value.
		dataStream flush]! !

!MDFileRepository methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
rescanData
	dataStream reopen.
	dataStream fromPosition: lastPosition keysValuesAndPositionsDo:  
		[:key :val :pos |
		index at: key put: pos.
		(MDMarshal isMemo:val) ifTrue:
			[memos add: (MDMarshal materialize: val)]].
	dataStream position = lastPosition
		ifTrue: [^ false]
		ifFalse: [lastPosition := dataStream position. ^ true]! !

!MDFileRepository methodsFor: 'initialize-release' stamp: 'cwp 7/27/2008 14:46'!
setStream: aFileStream 
	dataStream := MDKeyedStream on: aFileStream.
	lastPosition := 0.
	index := Dictionary new.
	memos := Set new.
	self rescanData! !

MDRepository subclass: #MDNetRepository
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

!MDNetRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 13:09'!
host: aString
	^ self link: (MDNetLink host: aString)! !

!MDNetRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 1/20/2008 12:27'!
host: aString port: anInteger
	^ self link: (MDNetLink host: aString port: anInteger)! !

!MDNetRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 1/4/2008 12:23'!
link: aLink
	^ self new setLink: aLink! !

!MDNetRepository class methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2008 14:51'!
type
	^ #Mnrp! !

!MDNetRepository methodsFor: 'synchronization' stamp: 'cwp 5/22/2008 00:11'!
allHashstamps
	| result |
	result := self send: MDGetHashstamps new.
	result assertMessageIs: MDAllHashstamps.
	^ result hashstamps! !

!MDNetRepository methodsFor: 'public' stamp: 'jf 10/25/2008 13:39'!
close
	| bye |
	link isOpen ifTrue: [
		bye := link send: MDGoodbye new.
		link close.
		bye assertMessageIs: MDGoodbye ]! !

!MDNetRepository methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2009 23:23'!
elementClass
	^ MDNetRepositoryElement! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
get: aHashstamp
	| objects |
	objects := self getAll: (Set with: aHashstamp).
	^ objects isEmpty ifFalse: [objects anyOne]! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
getAll: aCollection
	| result |
	result := self send: (MDGetObjects with: aCollection).
	result assertMessageIs: MDObjects.
	^ result objects! !

!MDNetRepository methodsFor: 'synchronization' stamp: 'cwp 1/8/2008 18:45'!
includes: aHashstamp
	^ (self get: aHashstamp) notNil! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 1/21/2008 20:41'!
locator
	^ link locator! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
memos
	| result |
	result := self send: MDGetMemos new.
	result assertMessageIs: MDMemos.
	^ result objects! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/31/2008 14:44'!
name
	^ link description! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 6/1/2008 01:24'!
properties: properties
	link := MDNetLink host: properties host port: properties port! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
put: anObject
	| result |
	result := self send: (MDPutObjects with: {anObject}). 
	result assertMessageIs: MDThankYou! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
putAll: aCollection
	| request |
	request := self send: (MDOfferObjects withObjects: aCollection).
	request assertMessageIs: MDRequestObjects.
	request 
		filter: aCollection
		in: [:put | (self send: put) assertMessageIs: MDThankYou]
! !

!MDNetRepository methodsFor: 'public' stamp: 'cwp 5/22/2008 00:11'!
selectFrom: aCollection
	| request |
	request := self send: (MDOfferObjects with: aCollection).
	request assertMessageIs: MDRequestObjects.
	^ request hashstamps! !

!MDNetRepository methodsFor: 'private' stamp: 'cwp 5/22/2008 00:11'!
send: aMessage
	| result |
	link isOpen ifFalse:
		[link open.
		result := link send: MDHello new.
		result assertMessageIs: MDHello].
	result := link send: aMessage.
	result checkForError.
	^ result! !

!MDNetRepository methodsFor: 'private' stamp: 'cwp 5/24/2008 13:19'!
setLink: aLink
	link := aLink.
	self initId! !

!MDNetRepository methodsFor: 'accessing' stamp: 'cwp 6/5/2008 21:46'!
update: properties
	super update: properties.
	^ self locator update: properties! !

MDTestCase subclass: #MDNetClientTest
	instanceVariableNames: 'link repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetClientTest methodsFor: 'running' stamp: 'cwp 5/22/2008 00:11'!
setUp
	link := MDMockLink new.
	repository := MDNetRepository link: link! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 14:15'!
testClose
	link
		open;
		expect: (MDGoodbye new);
		inject: (MDGoodbye new).
	repository close.
	self deny: link isOpen! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 20:51'!
testCloseProtocolError
	
	link
		open;
		expect: (MDGoodbye new);
		inject: (MDHello new).
	
	self
		should: [repository close]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 14:20'!
testDescription
	self assert: repository description = 'Mock'! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testGet
	| version result |
	version := self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	result := repository get: version hashstamp.
	self assert: result = version.
! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testGetAll
	| version result |
	version := self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	result := repository getAll: {version hashstamp}.
	self assert: result anyOne = version.
! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testGetAllNotFound
	| version result |
	version := self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: #()).
	result := repository getAll: {version hashstamp}.
	self assert: result isEmpty! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testGetAllProtocolError
	| version |
	version := self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDGoodbye new).
	
	self
		should: [repository getAll: {version hashstamp}]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testGetNotFound
	| version result |
	version := self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: #()).
	result := repository get: version hashstamp.
	self assert: result isNil! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testGetProtocolError
	
	| hashstamp |
	hashstamp := self version hashstamp.
	link
		open;
		expect: (MDGetObjects with: {hashstamp});
		inject: (MDGoodbye new).
	
	self
		should: [repository get: hashstamp]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testGetSome
	| a b result |
	a := self versionWith: #a.
	b := self versionWith: #b.
	link
		open;
		expect: (MDGetObjects with: {a hashstamp. b hashstamp});
		inject: (MDObjects with: {a}).
	result := repository getAll: {a hashstamp. b hashstamp}.
	self assert: result size = 1.
	self assert: result anyOne = a! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testHashstamps
	| memo result |
	memo := self memo.
	link
		open;
		expect: (MDGetHashstamps new);
		inject: (MDAllHashstamps with: {memo}).
	result := repository allHashstamps.
	self assert: result size = 1.
	self assert: result anyOne = memo! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 20:52'!
testHelloProtocolError
	
	link
		expect: (MDHello new);
		inject: (MDGoodbye new).
	
	self
		should: [repository memos]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testImplicitOpen
	| version |
	version := self version.
	link
		expect: MDHello new;
		inject: MDHello new;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	repository get: version hashstamp.! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testImplicitReopen
	| version |
	version := self version.
	link
		open;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	repository get: version hashstamp.
	link 
		close;
		expect: MDHello new;
		inject: MDHello new;
		expect: (MDGetObjects with: {version hashstamp});
		inject: (MDObjects with: {version}).
	repository get: version hashstamp.! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testMemos
	| memo result |
	memo := self memo.
	link
		open;
		expect: (MDGetMemos new);
		inject: (MDMemos with: {memo}).
	result := repository memos.
	self assert: result size = 1.
	self assert: result anyOne = memo! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 20:50'!
testMemosProtocolError
	
	link
		open;
		expect: (MDGetMemos new);
		inject: (MDHello new).
	
	self
		should: [repository memos]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testPut
	| version |
	version := self version.
	link
		open;
		expect: (MDPutObjects with: {version});
		inject: (MDThankYou with: 1).
	repository put: version.
	! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testPutAll
	| version |
	version := self version.
	link
		open;
		expect: (MDOfferObjects with: {version hashstamp});
		inject: (MDRequestObjects with: {version hashstamp});
		expect: (MDPutObjects with: {version});
		inject: (MDThankYou with: 1).
	repository putAll: {version}.
	! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testPutAllFailed
	| version |
	version := self version.
	link
		open;
		expect: (MDOfferObjects with: {version hashstamp});
		inject: (MDRequestObjects with: {version hashstamp});
		expect: (MDPutObjects with: {version});
		inject: (MDStorageFailed with: 'Just testing').
	self 
		should: [repository putAll: {version}]
		raise: MDPeerError! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testPutAllProtocolError1
	| version |
	version := self version.
	link
		open;
		expect: (MDOfferObjects with: {version hashstamp});
		inject: (MDThankYou new).
	self
		should: [repository putAll: {version}]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testPutAllProtocolError2
	| version |
	version := self version.
	link
		open;
		expect: (MDOfferObjects with: {version hashstamp});
		inject: (MDRequestObjects with: {version hashstamp});
		expect: (MDPutObjects with: {version});
		inject: (MDHello new).
	self
		should: [repository putAll: {version}]
		raise: MDProtocolError
	! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testPutFailed
	| version |
	version := self version.
	link
		open;
		expect: (MDPutObjects with: {version});
		inject: (MDStorageFailed with: 'Just testing').
	
	self
		should: [repository put: version]
		raise: MDPeerError! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testPutNone
	| a b |
	a := self versionWith: #a.
	b := self versionWith: #b.
	link
		open;
		expect: (MDOfferObjects with: {a hashstamp. b hashstamp});
		inject: (MDRequestObjects with: #()).
	repository putAll: {a. b}.
	link
		close
		expect: (MDGoodbye new);
		inject: (MDGoodbye new).
	repository close! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 8/9/2009 01:11'!
testPutProtocolError
	| version |
	version := self version.
	link
		open;
		expect: (MDPutObjects with: {version});
		inject: (MDHello new).
	
	self 
		should: [repository put: version]
		raise: MDProtocolError! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testPutSome
	| a b |
	a := self versionWith: #a.
	b := self versionWith: #b.
	link
		open;
		expect: (MDOfferObjects with: {a hashstamp. b hashstamp});
		inject: (MDRequestObjects with: {a hashstamp});
		expect: (MDPutObjects with: {a});
		inject: (MDThankYou with: 1).
	repository putAll: {a. b}.
	! !

!MDNetClientTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testSelectFrom
	| hashstamp result |
	hashstamp := self version hashstamp.
	link
		open;
		expect: (MDOfferObjects with: {hashstamp});
		inject: (MDRequestObjects with: {hashstamp}).
		
	result := repository selectFrom: {hashstamp} asSet.
	self assert: result size = 1.
	self assert: result anyOne = hashstamp! !

MDTestCase subclass: #MDNetLinkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testClose
	| link |
	link := MDNetLink locator: (MDFakeLocator new).
	link open.
	link locator mocket 
		execute: [link close];
		expectClose;
		done.! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testDescription
	| link |
	link := MDNetLink locator: (MDFakeLocator new).
	self assert: link description = 'Fake'! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testOpen
	| link |
	link := MDNetLink locator: (MDFakeLocator new).
	link open.
	self assert: link isOpen.
	self assert: link locator mocket isConnected.! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testSend
	| link mocket msg |
	link := MDNetLink locator: (MDFakeLocator new).
	mocket := link locator mocket.
	msg := MDHello with: 'test'.
	mocket
		execute: [link open; send: msg];
		expect: msg bytes;
		done! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testSendBeforeOpen
	| link msg |
	link := MDNetLink locator: (MDFakeLocator new).
	msg := MDHello with: 'test'.
	self 
		should: [link send: msg]
		raise: Error! !

!MDNetLinkTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testSendResponse
	| link mocket msg result |
	link := MDNetLink locator: (MDFakeLocator new).
	mocket := link locator mocket.
	msg := MDHello with: 'test'.
	mocket
		execute: 
			[link open.
			result := link send: msg.
			self assert: result class = MDHello];
		expect: msg bytes;
		inject: msg bytes! !

MDTestCase subclass: #MDNetSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetSerializationTest methodsFor: 'asserting' stamp: 'cwp 5/22/2008 00:11'!
assertEqualityOf: anObject
	| bytes other |
	bytes := anObject bytes.
	other := MDNetMessage fromBytes: bytes.
	self assert: anObject = other! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:30'!
testAuthenticationFailed
	self assertEqualityOf: (MDAuthenticationFailed with: 'Unknown user')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/8/2008 18:38'!
testGetHashstamps
	self assertEqualityOf: MDGetHashstamps new! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/3/2008 23:32'!
testGetMemos
	self assertEqualityOf: MDGetMemos new! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/3/2008 23:25'!
testGetObjects
	self assertEqualityOf: (MDGetObjects with: (Set with: self version hashstamp))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:40'!
testGoodbye
	self assertEqualityOf: (MDGoodbye with: 'colin@wiresong.ca')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/8/2008 18:17'!
testHashstamps
	self assertEqualityOf: (MDAllHashstamps with: (Set with: self version hashstamp))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:37'!
testHello
	self assertEqualityOf: (MDHello with: 'colin@wiresong.ca')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 5/22/2008 00:11'!
testIdConflict
	| messages others |
	messages := MDNetMessage allSubclasses select: [:ea | ea isConcrete].
	messages do:
		[:msg |
		others := messages copyWithout: msg.
		others do: [:other | self deny: msg id = other id]]! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:09'!
testMemos
	self assertEqualityOf: (MDMemos with: (Set with: self memo))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:34'!
testObjectNotFound
	self assertEqualityOf: (MDStorageFailed with: 'Disk full')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:08'!
testObjects
	self assertEqualityOf: (MDObjects with: (Set with: self version))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:23'!
testOfferObjects
	self assertEqualityOf: (MDOfferObjects with: (Set with: self version hashstamp))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:07'!
testPutObjects
	self assertEqualityOf: (MDPutObjects with: (Set with: self version))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:23'!
testRequestObjects
	self assertEqualityOf: (MDRequestObjects with: (Set with: self version hashstamp))! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/3/2008 23:53'!
testThankYou
	self assertEqualityOf: (MDThankYou with: 4)! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:31'!
testUnauthorized
	self assertEqualityOf: (MDUnauthorized with: 'That version is private')! !

!MDNetSerializationTest methodsFor: 'tests' stamp: 'cwp 1/4/2008 00:26'!
testUnrecognizedMessage
	self assertEqualityOf: (MDUnrecognizedMessage with: 'Message id 555 not implemented')! !

MDTestCase subclass: #MDNetServiceTest
	instanceVariableNames: 'service repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Tests'!

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
setUp
	repository := MDMemoryRepository new.
	service := MDNetService for: repository.! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testGetMemos
	| memo result |
	memo := self memo.
	repository put: memo.
	result := service handleMessage: (MDGetMemos new).
	self assert: result isMemos.
	self assert: (result objects includes: memo)! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testGetNotFound
	| a b result |
	a := self versionWith: #a.
	b := self versionWith: #b.
	repository put: b.
	result := service handleMessage: (MDGetObjects with: {a hashstamp. b hashstamp}).
	self assert: result isObjects.
	self assert: result objects size = 1.
	self assert: result objects anyOne = b.! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testGetObjects
	| version result |
	version := self version.
	repository put: version.
	result := service handleMessage: (MDGetObjects with: {version hashstamp}).
	self assert: result isObjects.
	self assert: (result objects includes: version)! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testGetPartial
	| version result |
	version := self version.
	result := service handleMessage: (MDGetObjects with: {version hashstamp}).
	self assert: result isObjects.
	self assert: result objects isEmpty! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testGoodbye
	| result |
	result := service handleMessage: MDGoodbye new.
	self assert: result isGoodbye! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testHello
	
	| result |
	result := service handleMessage: MDHello new.
	self assert: result isHello.
! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testOfferObjects
	| result a b |
	a := self versionWith: #a.
	b := self versionWith: #b.
	repository put: a.
	result := service handleMessage: (MDOfferObjects with: {a hashstamp. b hashstamp}).
	self assert: result isRequestObjects.
	self assert: result hashstamps size = 1.
	self assert: result hashstamps anyOne = b hashstamp.! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testOfferObjectsUnneeded
	| result version |
	version := self version.
	repository put: version.
	result := service handleMessage: (MDOfferObjects with: {version hashstamp}).
	self assert: result isRequestObjects.
	self assert: result hashstamps isEmpty! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testPutObjects
	| version result |
	version := self version.
	result := service handleMessage: (MDPutObjects with: {version}).
	self assert: result isThankYou.
	self assert: (repository get: version hashstamp) = version! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testPutObjectsFailed
	| version result |
	version := self version.
	service instVarNamed: 'repository' put: nil.
	result := service handleMessage: (MDPutObjects with: {version}).
	self assert: result class = MDStorageFailed.
	self assert: result description = 'MessageNotUnderstood: UndefinedObject>>putAll:'! !

!MDNetServiceTest methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2008 00:11'!
testServerError
	| version result |
	version := self version.
	service instVarNamed: 'repository' put: nil.
	result := service handleMessage: (MDGetObjects with: {version hashstamp}).
	self assert: result class = MDProcessingError.
	self assert: result description = 'MessageNotUnderstood: UndefinedObject>>getAll:'! !

Error subclass: #MDNetError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDNetError subclass: #MDPeerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!

MDNetError subclass: #MDProtocolError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repositories-Net'!
